















:- object browser : [bcilib].

do_set(T,F,X) :-
 format('begin set(~w,~w,~w)~n',[T,F,X]),
 set(T,F,X),!,
 format('end set(~w,~w,~w)~n',[T,F,X]).

set(T,F,mfstring(X)):- setMFString(T,F,X).
set(T,F,sfint32(X)):- setSFInt32(T,F,X).
set(T,F,sffloat(X)):- setSFFloat(T,F,X).
set(T,F,sftime(X)):- setSFTime(T,F,X).
set(T,F,sfcolor(R,G,B)):- setSFColor(T,F,R,G,B).
set(T,F,sfvec3f(X,Y,Z)):- setSFVec3f(T,F,X,Y,Z).
set(T,F,sfrotation(X,Y,Z,R)):- setSFRotation(T,F,X,Y,Z,R).

get(T,F,mfstring(X)):- getMFString(T,F,X).
get(T,F,sfint32(X)):- getSFInt32(T,F,X).
get(T,F,sffloat(X)):- getSFFloat(T,F,X).
get(T,F,sftime(X)):- getSFTime(T,F,X).
get(T,F,sfcolor(R,G,B)):- getSFColor(T,F,R,G,B).
get(T,F,sfvec3f(X,Y,Z)):- getSFVec3f(T,F,X,Y,Z).
get(T,F,sfrotation(X,Y,Z,R)):- getSFRotation(T,F,X,Y,Z,R).

observe(N,F,O) :- eventObserverObject(N,F,O).

fm([X],F,L) :- format_to_atom(X,F,L).

setfm(O,F,S):-
   fm(X,S,[]),
   set(O,F,mfstring(X)).

load(U) :- loadURL(U).

:- end_object browser.






:- object parameters : [ browser ].

var style = 0.
var r_string, l_string. %% string
var r_r_b, r_r_e, l_r_b, l_r_e. %% rotation
var r_p_b, r_p_e, l_p_b, l_p_e. %% position
var r_a_b, r_a_e, l_a_b, l_a_e. %% transparency
var r_c_b, r_c_e, l_c_b, l_c_e. %% color
var r_t_b, r_t_e, l_t_b, l_t_e. %% text (color)



set_defaults(X) :-
	format('set defaults~n',[]),
	set_defaults_right(X),
	set_defaults_left(X).



set_defaults_right(_) :-
	r_r_b := sfrotation(0.0,1.0,0.0,-0.5),
        r_r_e := sfrotation(0.0,1.0,0.0,-1.40),
	r_p_b := sfvec3f(0.0,0.0,1.8),
	r_p_e := sfvec3f(0.5,0,0),
	r_a_b := sffloat(0.1),
	r_a_e := sffloat(0.5),
	r_c_b := sfcolor(1,0,0),
	r_c_e := sfcolor(1,0,0),
	r_t_b := sfcolor(1,1,1),
	r_t_e := sfcolor(1,1,1),
	r_string := mfstring(['']),
	format('default right set~n',[]),
	!.

set_defaults_left(_) :-
	l_r_b := sfrotation(0.0,1.0,0.0,0.5),
        l_r_e := sfrotation(0.0,1.0,0.0,1.40),
	l_p_b := sfvec3f(0,0,1.8),
	l_p_e := sfvec3f(-0.5,0,0),
	l_a_b := sffloat(0.1),
	l_a_e := sffloat(0.5),
	l_c_b := sfcolor(0,0,1),
	l_c_e := sfcolor(0,0,1),
	l_t_b := sfcolor(1,1,0),
	l_t_e := sfcolor(1,1,0),
	l_string := mfstring(['']),
	format('default left set~n',[]),
	!.

set_plain_right(_) :-
	r_r_b := sfrotation(0.0,1.0,0.0,0.0),
        r_r_e := sfrotation(0.0,1.0,0.0,0.0),
	r_p_b := sfvec3f(0.0,0.0,0.0),
	r_p_e := sfvec3f(0.0,0.0,0.0),
	r_a_b := sffloat(0.1),
	r_a_e := sffloat(1.0),
	r_c_b := sfcolor(1,0,0),
	r_c_e := sfcolor(1,0,0),
	r_t_b := sfcolor(1,1,1),
	r_t_e := sfcolor(1,1,1),
	r_string := mfstring(['']),
	format('plain right set~n',[]),
	!.

set_plain_left(_) :-
	l_r_b := sfrotation(0.0,1.0,0.0,0.0),
        l_r_e := sfrotation(0.0,1.0,0.0,0.0),
	l_p_b := sfvec3f(0.0,0.0,0.0),
	l_p_e := sfvec3f(0.0,0.0,0.0),
	l_a_b := sffloat(0.1),
	l_a_e := sffloat(1.0),
	l_c_b := sfcolor(0,0,1),
	l_c_e := sfcolor(0,0,1),
	l_t_b := sfcolor(1,1,0),
	l_t_e := sfcolor(1,1,0),
	l_string := mfstring(['']),
	format('plain left set~n',[]),
	!.



do_action(P,D,T,N,L,[]) :- !.
do_action(P,D,T,N,L,[H|R]) :- !,
	do_action(P,D,T,N,L,H),!,
	do_action(P,D,T,N,L,R).
	
do_action(P,D,T,N,L,A) :-
   action(P,D,T,N,L,A),!,
   format('action: ~w ~w-~w ~w (~w) -- ~w~n',[P,D,T,N,L,A]).

do_action(P,D,T,N,L,A) :-
   set_style(P,D,T,N,L,A),!,
   format('set_style: ~w ~w-~w ~w (~w) -- ~w~n',[P,D,T,N,L,A]).

do_action(_,_,_,_,_,_).




pre_right(0) :- 
	set(right,rotation,r_r_b),
	set(right,set_position,r_p_b),
	set(right,transparency,r_a_b),
	set(right,color,r_c_b),
	set(right,text,r_t_b),
	!.
pre_right(_) :-
	%%format('failed: pre right~n',[]),
	!.

post_right(0) :- 
	set(right,rotation,r_r_e),
	set(right,set_position,r_p_e),
	set(right,transparency,r_a_e),
	set(right,string,r_string),
	set(right,color,r_c_e),
	set(right,text,r_t_e),
	!.
post_right(_) :-
	%%format('failed: post right',[]),
	!. 

pre_left(0) :- 
	set(left,rotation,l_r_b),
	set(left,set_position,l_p_b),
	set(left,transparency,l_a_b),
	set(left,color,l_c_b),
	set(left,text,l_t_b),
	!.
pre_left(_) :-
	%%format('failed: pre left',[]),
	!. 

post_left(0) :- 
	set(left,rotation,l_r_e),
	set(left,set_position,l_p_e),
	set(left,transparency,l_a_e),
	set(left,string,l_string),
	set(left,color,l_c_e),
	set(left,text,l_t_e),
	!.
post_left(_) :-
	%%format('failed: post left',[]),
	!. 



set_style(r,_D,_T,_N,_L,default) :- set_defaults_right(_), !. 
set_style(l,_D,_T,_N,_L,default) :- set_defaults_left(_), !. 

set_style(r,_D,_T,_N,_L,plain) :- set_plain_right(_), !. 
set_style(l,_D,_T,_N,_L,plain) :- set_plain_left(_), !. 

set_style(_P,_D,_T,_N,_L,defaults) :- set_defaults(_), !. 

set_style(_P,_D,_T,_N,_L,next(X)) :- !, set(X,next,sftime(0.0)). 

set_style(_P,_D,_T,_N,_L,humanoid=string(X)) :- !, setfm(humanoid,string,X). 
set_style(_P,_D,_T,_N,_L,humanoid=type(X)) :- !, set(humanoid,type,sfint32(X)). 
set_style(_P,_D,_T,_N,_L,humanoid=text(R,G,B)) :- !, set(humanoid,text,sfcolor(R,G,B)). 
set_style(_P,_D,_T,_N,_L,humanoid=balloon(X)) :- !, set(humanoid,dialog,sfint32(X)). 
set_style(_P,_D,_T,_N,_L,humanoid=persona(X)) :- !, set(humanoid,persona,sfint32(X)). 
set_style(_P,_D,_T,_N,_L,humanoid=visible(X)) :- !, set(humanoid,visible,sfint32(X)). 


set_style(r,_D,_T,_N,_L,string=0) :- !, r_string := mfstring([' ']), !. 
set_style(l,_D,_T,_N,_L,string=0) :- l_string := mfstring([' ']), !. 

set_style(r,_D,_T,_N,_L,string=X) :- !, r_string := mfstring([X]), !. 
set_style(l,_D,_T,_N,_L,string=X) :- !, l_string := mfstring([X]), !. 


set_style(r,_D,_T,_N,_L,a(b)=X) :- !, r_a_b := sfloat(X), !. 
set_style(r,_D,_T,_N,_L,a(e)=X) :- !, r_a_e := sffloat(X), !. 
set_style(l,_D,_T,_N,_L,a(b)=X) :- !, l_a_b := sffloat(X), !. 
set_style(l,_D,_T,_N,_L,a(e)=X) :- !, l_a_e := sffloat(X), !. 







set_style(r,_D,_T,_N,_L,p(b)=(X,Y,Z)) :- !, r_p_b := sfvec3f(X,Y,Z), !. 
set_style(r,_D,_T,_N,_L,p(e)=(X,Y,Z)) :- !, r_p_e := sfvec3f(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,p(b)=(X,Y,Z)) :- !, l_p_b := sfvec3f(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,p(e)=(X,Y,Z)) :- !, l_p_e := sfvec3f(X,Y,Z), !. 


set_style(r,_D,_T,_N,_L,r(b)=(X,Y,Z,R)) :- !, r_r_b := sfrotation(X,Y,Z,R), !. 
set_style(r,_D,_T,_N,_L,r(e)=(X,Y,Z,R)) :- !, r_r_e := sfrotation(X,Y,Z,R), !. 
set_style(l,_D,_T,_N,_L,r(b)=(X,Y,Z,R)) :- !, l_r_b := sfrotation(X,Y,Z,R), !. 
set_style(l,_D,_T,_N,_L,r(e)=(X,Y,Z,R)) :- !, l_r_e := sfrotation(X,Y,Z,R), !. 


set_style(r,_D,_T,_N,_L,color=(X,Y,Z)) :- !, r_c_b := sfcolor(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,color=(X,Y,Z)) :- !, l_c_b := sfcolor(X,Y,Z), !. 

set_style(r,_D,_T,_N,_L,c(b)=(X,Y,Z)) :- !, r_c_b := sfcolor(X,Y,Z), !. 
set_style(r,_D,_T,_N,_L,c(e)=(X,Y,Z)) :- !, r_c_e := sfcolor(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,c(b)=(X,Y,Z)) :- !, l_c_b := sfcolor(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,c(e)=(X,Y,Z)) :- !, l_c_e := sfcolor(X,Y,Z), !. 


set_style(r,_D,_T,_N,_L,text=(X,Y,Z)) :- !, r_t_b := sfcolor(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,text=(X,Y,Z)) :- !, l_t_b := sfcolor(X,Y,Z), !. 

set_style(r,_D,_T,_N,_L,t(b)=(X,Y,Z)) :- !, r_t_b := sfcolor(X,Y,Z), !. 
set_style(r,_D,_T,_N,_L,t(e)=(X,Y,Z)) :- !, r_t_e := sfcolor(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,t(b)=(X,Y,Z)) :- !, l_t_b := sfcolor(X,Y,Z), !. 
set_style(l,_D,_T,_N,_L,t(e)=(X,Y,Z)) :- !, l_t_e := sfcolor(X,Y,Z), !. 


set_style(r,_D,_T,_N,_L,balloon=X) :- !, set(right,dialog,sfint32(X)), !. 
set_style(l,_D,_T,_N,_L,balloon=X) :- !, set(left,dialog,sfint32(X)), !. 

set_style(r,_D,_T,_N,_L,bulb=X) :- !, set(right,dialog,sfint32(X)), !. 
set_style(l,_D,_T,_N,_L,bulb=X) :- !, set(left,dialog,sfint32(X)), !. 

set_style(r,_D,_T,_N,_L,dialog=X) :- !, set(right,dialog,sfint32(X)), !. 
set_style(l,_D,_T,_N,_L,dialog=X) :- !, set(left,dialog,sfint32(X)), !. 

set_style(r,_D,_T,_N,_L,persona=X) :- !, set(right,persona,sfint32(X)), !. 
set_style(l,_D,_T,_N,_L,persona=X) :- !, set(left,persona,sfint32(X)), !. 

set_style(r,_D,_T,_N,_L,visible=X) :- !, set(right,visible,sfint32(X)), !. 
set_style(l,_D,_T,_N,_L,visible=X) :- !, set(left,visible,sfint32(X)), !. 

set_style(r,_D,_T,_N,_L,bg=X) :- !, set(right,background,mfstring([X])), !. 
set_style(l,_D,_T,_N,_L,bg=X) :- !, set(left,background,mfstring([X])), !. 

set_style(r,_D,_T,_N,_L,p=(X,Y,Z)) :- !, set(right,translation,sfvec3f(X,Y,Z)), !. 
set_style(l,_D,_T,_N,_L,p=(X,Y,Z)) :- !, set(left,translation,sfvec3f(X,Y,Z)), !. 

set_style(_,_D,_T,_N,_L,sky=(X,Y,Z)) :- !, set(background,skyColor,sfvec3f(X,Y,Z)), !. 
set_style(_,_D,_T,_N,_L,logo=X) :- !, set(logo,string,mfstring([X])), !. 
set_style(_,_D,_T,_N,_L,drop=X) :- !, set(drop,whichChoice,sfint32(X)), !. 

set_style(P,_D,_T,_N,_L,F=X) :- !,
	format('unknown style (~w): ~w=~w~n',[P,F,X]).

set_style(P,D,T,N,L,A) :- !,
   format('unknown style: ~w ~w-~w ~w (~w) -- ~w~n',[P,D,T,N,L,A]).


:- end_object parameters.








:- object vrml.
var debug = 1.

notify(S) :- debug = 1,!,
	format('create ~w ~n',[S]).
notify(_).

tostring(' '). %% empty

stringof(S) :-
	tostring(S),
	notify(S).

:- end_object vrml.



:- object box : [vrml].
var x = 1, y = 1, z = 1.

set_size(S):- x := S, y := S, z := S.
get_size(S):- S = X.

set_size(X,Y,Z):- x := X, y := Y, z := Z.
get_size(X,Y,Z):- X = x, Y = y, Z = z.

stringof(S) :- format_to_atom(S,' box { size ~w ~w ~w } ',[x,y,z]), notify(S).


:- end_object box.





:- object objects : [ browser ].

xof(r,C,2).
xof(l,C,-2).
yof(R,C,Y):- Y is -1.5 + 0.2 * C.
zof(R,C,1).

aof(R,C,T) :- T is 0.8 - 0.8 * (max - C)/max.
sizeof(R,C,0.15).

colorof(r,C,'0 1 1').
colorof(l,C,'1 0 0').

object(R,C,X) :-
	sizeof(R,C,S),
	 O := new(box), O<-set_size(S), O<-stringof(X).
	%%format_to_atom(X,'Box { size ~w ~w ~w }',[S,S,S]).

translation(R,C,T) :- xof(R,C,X), yof(R,C,Y), zof(R,C,Z),
 format_to_atom(T,'translation ~w ~w ~w ',[X,Y,Z]).

material(R,C,M) :- colorof(R,C,Cl), aof(R,C,T),
 format_to_atom(M,'Material { diffuseColor ~w transparency ~w }',[Cl,T]).


deposit(R,C) :- !,
  object(R,C,Obj),
  material(R,C,Mat),
  format_to_atom(App,'Appearance { material ~w }',[Mat]),
  format_to_atom(Shape,'DEF shape-~w-~w Shape { geometry ~w appearance ~w }',[R,C,Obj,App]),
  translation(R,C,T),
  format_to_atom(Touch,'DEF touch-~w-~w TouchSensor { }',[R,C]),
  format_to_atom(Decl,'directOutput TRUE eventIn SFTime touch field SFNode shape USE shape-~w-~w',[R,C]),
  format_to_atom(Fun,'function touch(v) { shape.appearance.material.diffuseColor = new SFColor(1,1,0); }',[]),
  format_to_atom(Body,'~w url \\"javascript: ~w\\"',[Decl,Fun]),
  format_to_atom(Script,'DEF script-~w-~w Script { ~w }',[R,C,Body]),
  format_to_atom(Route,'ROUTE touch-~w-~w.touchTime TO script-~w-~w.touch',[R,C,R,C]),
  format_to_atom(Trans,'Transform { ~w  children [~w ~w ~w ~w]}',[T,Shape,Touch,Script,Route]),
  createVrmlFromString(Trans,root,_),
  format('deposit ~w ~w ~w ~n',[R,C,Trans]),
  !.

deposit(_,_).

:- end_object objects.



                           

                           
:-object soccer : [bcilib].

var timelimit = 3.
var count = 0.


kick :-
	format('the game will start in 5 seconds,~n'),
	format('note that the total playing time period is ~w seconds,~n', [timelimit]),
	%%delay(5000),
	format('the game startup,~n'),
	setSFInt32(footballer,gesture,3),
	play_ball(me,ball),
	format('end of game~n'),
	getPosition(goalkeeper,X,Y,Z),
	X1 is X - 2,
	setPosition(ball,X1,-4,Z),
	setSFInt32(goalkeeper,gesture,2),
	setSFInt32(footballer,gesture,5),
	delay(500),
	setSFInt32(footballer,visible,-1).


play_ball(Agent, Ball) :-
	repeat,
	++count,
	format('time: ~w seconds~n', [count]),
	%%delay(800),
	%%look_at_ball(goalkeeper,Ball),
	%%R is R1 - 1.5708,
	near_ball_then_kick(Agent, Ball),
	timelimit = count.

play_ball(_, _).


near_ball_then_kick(Agent, Ball):- 
	%%getPosition(goalkeeper,X,_Y,Z),
	getPosition(Ball,X1,Y1,Z1),
	%%D is X-X1,
	%%D > 2, !,
	Xdif = 5,
	Zdif = 0.2,
	%%Dist is sqrt(Xdif*Xdif + Zdif*Zdif),
	X2 is Xdif*3,
	Z2 is Zdif*0.5,
	X3 is X2 + X1,
	Z3 is Z2 + Z1,
	setPosition(Ball,X3,Y1,Z3),
	checkBallPosition(Ball,X3,Y1,Z3).

near_ball_then_kick(_, _).

checkBallPosition(Ball, X, Y, Z):-
	getPosition(goalkeeper,X1,Y1,Z1),
	Zdif is Z-Z1,
	Z2 is (Z - Z1) * 0.25,
	setPosition(goalkeeper,X1,Y1,Z2).
	%%look_at_ball(goalkeeper,Ball).



	
look_at_ball(Sportman,Ball):-
	getPosition(Sportman,X,_,Z),
	getPosition(Ball, X1,_,Z1),
	Xdif is X-X1,
	Zdif is Z1-Z,
	Xdif =\= 0.0, !,
	R1 = atan(Zdif/Xdif),
	R is R1 - 1.5708,
	setSFInt32(Sportman,gesture,2),
	setRotation(Sportman,0.0, 1.0, 0.0, R).	
	
look_at_ball(_,_).

:-end_object soccer.





















:-object step : [bcilib, do_script, gesturelib].

     var url = './h-anim/step.wrl'.
	main:-
		format('Loading the humaniod from ~w~n', [url]),
		format('Please wait ...~n'),
		loadURL(url),
		sleep(6000),
		script_threads,
%		change the next line to test your own scripting action
		process_script(test(humanoid)),
		process_script(taichi(humanoid)),
		true.

	select_script(Name,Script) :-
		script(Name, Script).

	turn_body_part(Agent,Body,Direction,Speed):-
		getBodyObjectName(Agent,Body,Object),
		getRotationParameter(Body,Direction,Rotation),
		getSpeedParameter(Body,Speed,Beat,Interpolation),
		!,
		turn_object(Object,Rotation,Beat,Interpolation).

	turn_body_part_init(Agent,Body,Direction):-
		getBodyObjectName(Agent,Body,Object),
		getRotationParameter(Body,Direction,rotation(X,Y,Z,_R)),
		!,
		setRotation(Object,X,Y,Z,0.0).


	move_body(Agent,Body,Direction,Speed):-
		getBodyObjectName(Agent,Body,Object),
		getPositionParameter(Body,Direction,Position),
		getSpeedParameter(Body,Speed,Beat,Interpolation),
		!,	
		move_object(Object,Position,Beat,Interpolation).

:-end_object step.

:-object do_script : [bcilib].
	var count = 0.
	var repcnt = 0.
	var max_threads = 12.
	var incrementr = 0.
	var sleeptime = 0.
	var incrementx = 0.
	var incrementy = 0.
	var incrementz = 0.
	var tempo = 60.
	script_threads :-
		set_field(answer_entry, free),
		set_field(thread_entry, free),
		new_array(script, thread_entry, max_threads),
		new_array(script, answer_entry, max_threads),
		script_threads(max_threads).
 	script_threads(0) :-
                !.
 	script_threads(I) :-
                N is I - 1,
		set_array(script, thread_entry, N, free),
		set_array(script, answer_entry, N, free),
                new(do_action(N), _),
                script_threads(N).
	select_entry(ArrayName, ThreadID) :-
		get_field_event(ArrayName, _Flag),
		NextThread is max_threads - 1,
		select_entry(NextThread, ArrayName, ThreadID),
		set_field(ArrayName, free).
	select_entry(I, ArrayName, _) :-
		I < 0,
		!,
		true.
		
	select_entry(I, ArrayName, ThreadID) :-
		get_array(script, ArrayName, I, State),
		State = free,
		!,
		set_array(script, ArrayName, I, lock),
		ThreadID = I.
	select_entry(I, ArrayName, Thread) :-
		N is I - 1,
		select_entry(N, ArrayName, Thread).
	release_entry(I, ArrayName) :-
		get_field_event(ArrayName, Flag),
		set_array(script, ArrayName, I, free),
		set_field(ArrayName, free).
	repeat_script(ScriptName, MaxCount) :-
		repcnt := 1,
		repeat,
			process_script(ScriptName),
			++ repcnt,				
		repcnt > MaxCount,
		!.
	process_script(ScriptName):-
		select_script(ScriptName, ScriptCode),
		do_script(ScriptCode).
	do_script([]) :-
		!.


humanoid_objects(true).

        speak_phrase(Agent, Phrase) :- speak_phrase(Agent,Phrase,[]).

        speak_phrase(Agent, Phrase,L) :-
		%%format(Phrase,[]),
		humanoid_objects(true),
		format_to_atom(X,Phrase,L),
		setMFString(Agent,string,[Phrase]),
		!.

        speak_phrase(Agent, Phrase,L) :-
		format(Phrase,L),
		!.


	set_style(_,_) :- humanoid_objects(X), not( X = true ), !.

	set_style(Agent,[]) :- !.
	set_style(Agent,[H|T]) :-
		set_style(Agent,H),
		set_style(Agent,T).
	
	set_style(Agent,balloon=X) :- !, setSFInt32(Agent,balloon,X).
	set_style(Agent,a=X) :- !, setSFFloat(Agent,transparency,X).
	set_style(Agent,text=(R,G,B)) :- !, setSFColor(Agent,text,R,G,B).
	set_style(Agent,color=(R,G,B)) :- !, setSFColor(Agent,color,R,G,B).


	do_script([Action | Y]) :-
		Action = speak(Agent,Phrase),
		!,
		speak_phrase(Agent,Phrase),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = speak(Agent,Phrase,L),
		!,
		speak_phrase(Agent,Phrase,L),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = speak(Agent,Phrase,L,S),
		!,
		set_style(Agent,S),
		speak_phrase(Agent,Phrase,L),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = style(Agent,Style),
		!,
		set_style(Agent,Style),
		do_script(Y).


	do_script([Action | Y]) :-
		Action = turn(Agent,Object,Direction,Speed),
		!,
		turn_body_part(Agent,Object,Direction,Speed),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = turn_init(Agent,Object,Direction),
		!,
		turn_body_part_init(Agent,Object,Direction),
		do_script(Y).


	do_script([Action | Y]) :-
		Action = [SubAction | SubActionList],
		!,
		do_script([SubAction]),
		do_script(SubActionList),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = move(Agent,Direction,Speed),
		!,
		move_body(Agent,humanoidroot,Direction,Speed),
		do_script(Y).
	do_script([Action | Y]) :-
		Action = set_tempo(Tempo),
		!,
		format('gesture action: ~w~n', [Action]),
		tempo := Tempo,
		do_script(Y).
	do_script([Action | Y]) :-
		Action = wait(Time),
		!,
		SleepTime is Time * 1000,
		sleep(SleepTime),
		do_script(Y).
	do_script([Action | Y]) :-
		Action = skip(_Action),
		!,
		do_script(Y),
		true.
	do_script([Action | Y]) :-
		Action = skip,
		!,
		do_script(Y),
		true.
	do_script([Action | Y]) :-
		Action = parallel(ActionList),
		!,
%		format('parallel action list: ~w~n', [ActionList]),
		length(ActionList, ActionListLength),
		%% select a free answer slot :
		select_entry(answer_entry, Answer),
		count_down_init(Answer, ActionListLength),
%               format('ActionListLength : ~w~n', [ActionListLength]),
		process_parallel_action(ActionList, Answer),
		format_to_atom(Parent, 'parent_~w', [Answer]),
		get_field_event(Parent, ReplyValue),
%		format('all worker threads done : ~w (answer id ~w)~n', [ReplyValue, Answer]),
		release_entry(Answer, answer_entry),
		do_script(Y).
	do_script([Action | Y]) :-
		Action = script(ScriptName),
		!,
		process_script(ScriptName),
		do_script(Y).
	do_script([Action | Y]) :-
		Action = repeat(Script,Times),
		!,
		repeat_script(Script, Times),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = choice([Actions]),
		!,
		process_choice([Actions]),
		do_script(Y).

	do_script([Action | Y]) :-
		Action = do(Goal),
		!,

		inspect_goal(Goal),
		do_script(Y),
		true.

	do_script([Action | Y]) :-
		Action = test(State),
		!,
		inspect_goal(State),
		do_script(Y),
		true.

	do_script([Action | Y]) :-
		Action = star(Action1),
		!,
		process_star(Action1),
		do_script(Y),
		true.

	do_script([Action |Y]) :-
		!,
		format('unknown gesture action: ~w~n', [Action]),
		do_script(Y).
	do_script(Action) :-
		format('unknown gesture action:~w (not a list)~n', [Action]).

     

	process_choice([]):-!.

	process_choice([Action|_Y]):-
			do_script(Action),
			!.

	process_choice([_Action|Y]):-
			process_choice(Y),
			!.
	process_star(Action):-
			do_script(Action),
			!.

	process_star(Action):-
			!,
			process_star(Action),
			true.


	inspect_goal((Goal1,Goal2)) :-
		!,
		do_goal(Goal1),
		inspect_goal(Goal2).
	inspect_goal(Goal) :-
		do_goal(Goal).
	do_goal(setRotation(O,X,Y,Z,R)) :-
		!,
		setRotation(O,X,Y,Z,R).
	do_goal(getRotation(O,X,Y,Z,R)) :-
		!,
		getRotation(O,X,Y,Z,R).

	do_goal(setPosition(O,X,Y,Z)) :-
		!,
		setPosition(O,X,Y,Z).

	do_goal(getPosition(O,X,Y,Z)) :-
		!,
		getPosition(O,X,Y,Z).

	do_goal(getBodyObjectName(A,O,N)) :-
		!,
		gesturelib <- getBodyObjectName(A,O,N).

	do_goal(Goal):-
		call(Goal).
		
	count_down_init(Answer, Counter) :-
		set_array(script, answer_entry, Answer, Counter).
	count_down_join(Answer, ThreadID) :-
		get_field_event(answer_entry, _Flag),
		get_array(script, answer_entry, Answer, C),
%		format('count_down_join : a = ~w, c = ~w, t = ~w~n', [Answer,C,ThreadID]),
                C1 is C - 1,
                set_array(script, answer_entry, Answer, C1),
		set_field(answer_entry, free),
                count_down_last(C1, Answer).
        count_down_last(C, Answer) :-
                C =< 0,
                !,
		format_to_atom(Parent, 'parent_~w', [Answer]),
                %% set_queue(Parent, done).
		%% use field instead :
                set_field(Parent, done).
        count_down_last(_, _).
	turn_object(Object, rotation(X,Y,Z,R), Time, Interpolation):-
		getRotation(Object,X1,Y1,Z1,R1),
		%% format('start Rotation:<~w,~w,~w,~w>~n',[X1,Y1,Z1,R1]),
		count := 0,
		incrementr := (R-R1)/Interpolation,
		incrementx := (X-X1)/Interpolation,
		incrementy := (Y-Y1)/Interpolation,
		incrementz := (Z-Z1)/Interpolation,
		sleeptime := (60/tempo)*Time*1000/Interpolation,
		repeat,
			Rnew is R1+incrementr*(count+1),
			Xnew is X1+incrementx*(count+1),
			Ynew is Y1+incrementy*(count+1),
			Znew is Z1+incrementz*(count+1),			
			setRotation(Object,Xnew,Ynew,Znew,Rnew),
			sleep(sleeptime),
			++count,
		abs(Rnew-R) =< abs(incrementr),
		setRotation(Object,X,Y,Z,R),
		!.
	
	move_object(Object, increment(X,Y,Z), Time, Interpolation):-
		getSFVec3f(Object,translation,X1,Y1,Z1),
		count:=0,
		X_increment is X/Interpolation,
		Y_increment is Y/Interpolation,
		Z_increment is Z/Interpolation,
		SleepTime is (60/tempo)*Time*1000/Interpolation,
		repeat,
			Xnew is X1 + X_increment*(count+1),
			Ynew is Y1 + Y_increment*(count+1),
			Znew is Z1 + Z_increment*(count+1),
			setSFVec3f(Object,translation, Xnew,Ynew,Znew),
			sleep(SleepTime),
			++count,
		count >= Interpolation,
		setSFVec3f(Object,translation, X,Y,Z),
		!.
	process_parallel_action([], _Answer) :-
		!.
	process_parallel_action([Action | List], Answer) :-
		select_entry(thread_entry, I),
		%% format('parallel : thread = ~w, answer = ~w, action = ~w~n', [I,Answer,Action]),
		format_to_atom(Queue, 'queue_~w', [I]),
                set_queue(Queue, task(Action,Answer)),
                process_parallel_action(List, Answer).
	look_at_audience(Agent,Viewpoint):-
		getSFVec3f(Viewpoint,position,X,_Y,Z),
		look_at_position(Agent,X,Z),
		true.
	look_at_position(Agent,X1,Z1) :-
		getSFVec3f(Agent,translation, X,_,Z),
		X =\= X1,
		!,	%% RS: added
		Xdif is X-X1,
		Zdif is Z1-Z,
		R is atan(Zdif/Xdif) - sign(X-X1)*1.5708,
		setRotation(Agent,0.0, 1.0, 0.0, R).
	look_at_position(_, _, _).
:-end_object do_script.
:-object do_action : [bcilib, do_script, gesturelib].
	do_action(ThreadID) :-
		format_to_atom(Queue, 'queue_~w', [ThreadID]),
		repeat,
			get_queue(Queue, task(Action, Answer)),
			%% format('~w gets action ~w (answer = ~w)~n', [Queue,Action,Answer]),
			do_script([Action]),
			count_down_join(Answer, ThreadID),
			release_entry(ThreadID, thread_entry),
		fail.
	select_script(Name, Script) :-
		script(Name, Script).
	turn_body_part(Agent,Body,PoserR,Speed):-
		%% format('turn_body_part : A=~w, B=~w, P=~w, S=~w~n', [Agent,Body,PoserR,Speed]),
		getBodyObjectName(Agent,Body,Object),
		getRotationParameter(Body,PoserR,Rotation),
		getSpeedParameter(Body,Speed,Time,Interpolation),
		!,
		turn_object(Object,Rotation,Time,Interpolation).

	turn_body_part_init(Agent,Body,Direction):-
		getBodyObjectName(Agent,Body,Object),
		getRotationParameter(Body,Direction,rotation(X,Y,Z,_R)),
		!,
		setRotation(Object,X,Y,Z,0.0).

	move_body(Agent,Body,Direction,Speed):-
		getBodyObjectName(Agent,Body,Object),
		getPositionParameter(Body,Direction,Position),
		getSpeedParameter(Body,Speed,Time,Interpolation),
		!,	
		move_object(Object,Position,Time,Interpolation).



        speak_phrase(Agent, Phrase) :-
		format(Phrase,[]),
		%%format_to_atom(X,Phrase,[]),
		%%setMFString(Agent,string,[Phrase]),
		true.


:-end_object do_action.
:-object gesturelib : [ bcilib ].
	var unit_interpolation = 6.0.
	
	

script(walk(Agent), ActionList) :-
		ActionList = [
				parallel([turn(Agent,r_shoulder,back_down2,fast),
				turn(Agent,r_hip,front_down2,fast),
		turn(Agent,l_shoulder,front_down2,fast),
		turn(Agent,l_hip,back_down2,fast)]),
		parallel([turn(Agent,l_shoulder,back_down2,fast),
		turn(Agent,l_hip,front_down2,fast),
		turn(Agent,r_shoulder,front_down2,fast),
		turn(Agent,r_hip,back_down2,fast)])
		],
		!.

script(walk(Agent,StepLength), ActionList) :-
		ActionList = [parallel([script(walk(Agent)),
						move(Agent,increment(0.0,0.0,StepLength),fast)
						])
				
				],
		!.

script(get_adjustY(Agent, Y), ActionList) :-
		ActionList = [ do(getBodyObjectName(Agent, l_ankle, ObjectName)),
				   do(getPosition(ObjectName,_X1,Y1,_Z1)),
				   turn(Agent,l_hip,back_down2,fast),
				   do(getPosition(ObjectName,_X2,Y2,_Z2)),
				   do(Y is Y2-Y1),
				   turn(Agent,l_hip,down,fast)
				   ],
				   !.


script(walk_adjustY(Agent,Y,StepLength), ActionList) :-
		ActionList = [do(Y1 is -Y),
				  parallel([script(walk(Agent)),
				 [move(Agent,increment(0.0,Y,StepLength),very_fast),
				  move(Agent,increment(0.0,Y1,StepLength),very_fast)]
						])
				
				],
		!.




	script(fast_walk(Agent), ActionList) :-
		ActionList = [
			set_tempo(300),
			parallel([turn(Agent,r_shoulder,back_down2,fast),
		turn(Agent,r_hip,front_down2,fast),
		turn(Agent,l_shoulder,front_down2,fast),
		turn(Agent,l_hip,back_down2,fast)]),
		parallel([turn(Agent,l_shoulder,back_down2,fast),
		turn(Agent,l_hip,front_down2,fast),
		turn(Agent,r_shoulder,front_down2,fast),
		turn(Agent,r_hip,back_down2,fast)])
		],
		!.

	script(walk_front(Agent), ActionList) :-
		ActionList = [
		parallel([turn(Agent,r_shoulder,back_down2,fast),
				turn(Agent,r_hip,front_down2,fast),
				move(Agent,front,fast),
				turn(Agent,l_shoulder,front_down2,fast),
				turn(Agent,l_hip,back_down2,fast)]),
		parallel([turn(Agent,l_shoulder,back_down2,fast),
				turn(Agent,l_hip,front_down2,fast),
				move(Agent,front,fast),
				turn(Agent,r_shoulder,front_down2,fast),
				turn(Agent,r_hip,back_down2,fast)])
		],
		!.
	script(jump(Agent), ActionList) :-
		ActionList = [
		turn_init(Agent,l_shoulder,up),
		parallel([turn(Agent,r_knee,back,fast),
				turn(Agent,r_hip,front_down,fast),
				move(Agent,down,fast),
				turn(Agent,r_shoulder,up,fast),
				turn(Agent,l_shoulder,up,fast),
				turn(Agent,l_knee,back,fast),
				turn(Agent,l_hip,front_down,fast)]),
		turn_init(Agent,l_shoulder,left),
		parallel([turn(Agent,l_knee,down,fast),
				turn(Agent,l_hip,down,fast),
				move(Agent,up,fast),
				turn(Agent,r_shoulder,right,fast),
			 	turn(Agent,l_shoulder,left,fast),
				turn(Agent,r_knee,down,fast),
				turn(Agent,r_hip,down,fast)]),
		turn_init(Agent,l_shoulder,down_from_front),
		parallel([move(Agent,up,fast),
			   turn(Agent,r_shoulder,down_from_front,fast),
			   turn(Agent,l_shoulder,down_from_front,fast)]),
		
		move(Agent,down,fast)
		],
		!.
	
script(stand1(Agent), ActionList) :-
		ActionList = [parallel([turn(Agent,l_shoulder,down,fast),
		turn(Agent,skullbase,front,fast),
		turn(Agent,r_shoulder,down,fast),
		turn(Agent,l_hip,down,fast),
		turn(Agent,r_hip,down,fast),
		turn(Agent,l_knee,back_down2,fast),
		turn(Agent,r_knee,back_down2,fast),
		turn(Agent,r_wrist,down,fast),
		turn(Agent,l_wrist,down,fast),
		turn(Agent,r_elbow,down,fast),
		turn(Agent,l_elbow,down,fast)
		])
		],
		!.

	script(stand2(Agent), ActionList) :-
		ActionList = [
		turn_init(Agent,r_shoulder,down),
		parallel([turn(Agent,l_shoulder,down,fast),
		turn(Agent,r_shoulder,down,fast),
		turn(Agent,skullbase,front,fast),
		turn(Agent,l_hip,down,fast),
		turn(Agent,r_hip,down,fast)]),
		parallel([turn(Agent,l_knee,down,fast),
		turn(Agent,r_knee,down,fast)])
		],
		!.
	script(kicking(Agent), ActionList) :-
		ActionList = [
			parallel([turn(Agent,r_hip,back_down,fast),
					turn(Agent,r_knee,back,fast),
					turn(Agent,r_shoulder,front_down2,fast),
					turn(Agent,l_shoulder,back_down2,fast)
					]),
			parallel([turn(Agent,r_hip,front,fast),
					turn(Agent,r_knee,front_down2,fast),
					turn(Agent,l_shoulder,front_down2,fast),
					turn(Agent,r_shoulder,back_down2,fast)
					])
		],
		!.
	
	
				
	script(kneeing(Agent), ActionList) :-
		ActionList = [parallel([turn(Agent, r_elbow, front, fast), 
				turn(Agent, l_elbow, front, fast)]),
				parallel([turn(Agent, l_hip, front_down2, fast),
				turn(Agent, r_hip, front_down2, fast),
				turn(Agent, l_knee, back, fast),
				turn(Agent, r_knee, back, fast)])
		],
		!.
	script(start_run(Agent), ActionList) :-
		ActionList = [parallel([turn(Agent, r_elbow, front, fast), 
				turn(Agent, l_elbow, front, fast)]),
				parallel([turn(Agent, l_hip, front_down2, fast),
				turn(Agent, r_hip, front_down2, fast),
				turn(Agent, l_knee, back_down, fast),
				turn(Agent, r_knee, back_down, fast)])
		],
		!.
	script(run1(Agent), ActionList) :-
		ActionList = [parallel([turn(Agent,r_shoulder,back_down2,fast),
		turn(Agent,r_hip,front,fast),
		turn(Agent,l_shoulder,front_down2,fast),
		turn(Agent,l_hip,back_down2,fast)]),
		parallel([turn(Agent,l_shoulder,back_down2,fast),
		turn(Agent,l_hip,front,fast),
		turn(Agent,r_shoulder,front_down2,fast),
		turn(Agent,r_hip,back_down2,fast)])
		],
		!.
	script(run(Agent), ActionList) :-
		ActionList = [parallel([turn(Agent,r_shoulder,back_down2,fast),
		turn(Agent,r_hip,front_down,fast),
		turn(Agent,l_shoulder,front_down2,fast),
		turn(Agent,l_hip,back_down2,fast)]),
		parallel([turn(Agent,l_shoulder,back_down2,fast),
		turn(Agent,l_hip,front_down,fast),
		turn(Agent,r_shoulder,front_down2,fast),
		turn(Agent,r_hip,back_down2,fast)])
		],
		!.
	script(l_wave(Agent), ActionList) :-
		ActionList = [turn(Agent,l_shoulder,left_front_up,fast),
		turn(Agent,l_shoulder,left_front2_up,fast)],
		!.
	script(l_wave2(Agent), ActionList) :-
		ActionList = [turn(Agent,l_shoulder,left_front_up,fast),
		turn(Agent,l_shoulder,up_turn_90,fast)],
		!.
	script(r_wave(Agent), ActionList) :-
		ActionList = [turn(Agent,r_shoulder,right_front_up,fast),
		turn(Agent,r_shoulder,right_front2_up,fast)],
		!.
	script(r_wave2(Agent), ActionList) :-
		ActionList = [turn(Agent,r_shoulder,right_front_up,fast),
		turn(Agent,r_shoulder,up_turn_90,fast)],
		!.
	script(greeting(Agent), ActionList) :-
		ActionList = [parallel([
				turn_init(Agent,r_shoulder,right_front_up),
				repeat(l_wave2(Agent),8),
				repeat(r_wave2(Agent),8)]),
				  script(stand2(Agent)),
				  wait(1.0)
		],
		!.
	script(open_leg1(Agent), ActionList) :-
		ActionList = [parallel([turn(Agent,l_hip,side1_down,fast),
				turn(Agent,r_hip,side1_down,fast)])],
		!.
	
	
	script(test(Agent), ActionList) :-
		ActionList = [
		do(format('Agent action: walking~n')),
		repeat(walk(Agent), 6),
		do(format('Agent action: kicking~n')),
		repeat(kicking(Agent), 6),
		script(stand1(Agent)),
		do(format('Agent action: running~n')),
		script(start_run(Agent)),
		repeat(run(Agent), 6),
		script(stand1(Agent)),
		do(format('Agent action: jumping~n')),
		repeat(jump(Agent), 6),
		script(stand1(Agent)),
		do(format('Agent action: greeting~n')),
		repeat(greeting(Agent), 3),
		script(stand1(Agent))
		],
		!.



	script(taichi(Agent), ActionList) :-
		ActionList = [
		do(format('Agent action: taichi~n')),
		script(taichi(Agent, stage0)),
	%	script(taichi(Agent, stage2)),
	%	turn(Agent,humanoidroot,turn_45,very_slow),
		script(stand1(Agent))
	%	turn(Agent,humanoidroot,turn_45,very_slow)
		],
		!.

script(taichi(Agent, stage0), ActionList) :-
		ActionList = [
		speak(Agent, 'turn the hips'),
		turn(Agent,l_hip,side1_down,fast),
		turn(Agent,r_hip,side1_down,fast),
		style(Agent,text=(0,0,1)),
		speak(Agent,'slowly'),
		turn_init(Agent,l_shoulder,front),
		turn_init(Agent,r_shoulder,front),
		style(Agent,color=(1,0,0)),
		speak(Agent,'raise your arms'),
		parallel([turn(Agent,l_shoulder,front,slow),
			    turn(Agent,r_shoulder,front,slow)]),
		turn_init(Agent,l_elbow,front_right2),
		parallel([turn(Agent,l_shoulder,front_down,slow),
			    turn(Agent,r_shoulder,front_down,slow),
			    turn(Agent,l_elbow,front_right2,slow),
			    turn(Agent,r_elbow,front_left2,slow)]),
		turn_init(Agent,l_hip,left_front_down),
		turn_init(Agent,r_hip,right_front_down),
 		turn_init(Agent,l_knee,back2_down),
		turn_init(Agent,r_knee,back2_down),
		turn_init(Agent,l_elbow,right_front_down),
		speak(Agent,'now, just watch'),
		parallel([
			    move(Agent,increment(0.0,-0.1,0.0),slow),
			    turn(Agent,l_hip,left_front_down,slow),
			    turn(Agent,r_hip,right_front_down,slow),
			    turn(Agent,l_elbow,right_front_down,slow),
			    turn(Agent,r_shoulder,front_down2,slow),
			    turn(Agent,l_knee,back2_down,slow),
			    turn(Agent,r_knee,back2_down,slow)]),
		speak(Agent,'complete the first stage'),
		turn_init(Agent,l_shoulder,left_front_up2),
		turn_init(Agent,r_elbow,front),
		parallel([turn(Agent,l_shoulder,left_front_up2,very_slow),
				turn(Agent,r_wrist,turn_n45,slow),
				turn(Agent,r_elbow,front,slow),
			    turn(Agent,r_shoulder,front_left,very_slow)]),
		speak(Agent,'and slowly turn the wrists'),
		parallel([turn(Agent,l_wrist,turn_90,slow),
			    turn(Agent,r_wrist,turn_90,slow)])
		],
		!.

script(taichi(Agent, stage1), ActionList) :-
		ActionList = [
		turn(Agent,l_hip,side1_down,fast),
		turn(Agent,r_hip,side1_down,fast),
		turn_init(Agent,l_shoulder,front),
		turn_init(Agent,r_shoulder,front),
		parallel([turn(Agent,l_shoulder,front,slow),
			    turn(Agent,r_shoulder,front,slow)]),
		turn_init(Agent,l_elbow,front_right2),
		parallel([turn(Agent,l_shoulder,front_down,slow),
			    turn(Agent,r_shoulder,front_down,slow),
			    turn(Agent,l_elbow,front_right2,slow),
			    turn(Agent,r_elbow,front_left2,slow)]),
		turn_init(Agent,l_hip,left_front_down),
		turn_init(Agent,r_hip,right_front_down),
 		turn_init(Agent,l_knee,back2_down),
		turn_init(Agent,r_knee,back2_down),
		turn_init(Agent,l_elbow,right_front_down),
		parallel([
			    move(Agent,increment(0.0,-0.1,0.0),slow),
			    turn(Agent,l_hip,left_front_down,slow),
			    turn(Agent,r_hip,right_front_down,slow),
			    turn(Agent,l_elbow,right_front_down,slow),
			    turn(Agent,r_shoulder,front_down2,slow),
			    turn(Agent,l_knee,back2_down,slow),
			    turn(Agent,r_knee,back2_down,slow)]),
		turn_init(Agent,l_shoulder,left_front_up2),
		turn_init(Agent,r_elbow,front),
		parallel([turn(Agent,l_shoulder,left_front_up2,very_slow),
				turn(Agent,r_wrist,turn_n45,slow),
				turn(Agent,r_elbow,front,slow),
			    turn(Agent,r_shoulder,front_left,very_slow)]),
		parallel([turn(Agent,l_wrist,turn_90,slow),
			    turn(Agent,r_wrist,turn_90,slow)])
		],
		!.

script(taichi(Agent, stage2), ActionList) :-
		ActionList = [
		turn_init(Agent,humanoidroot,turn_n45),
		parallel([turn(Agent,humanoidroot,turn_n45,very_slow),
		turn(Agent,r_shoulder,right_front_down,very_slow),
		turn(Agent,r_knee,back_down2,very_slow)]),
		parallel([turn(Agent,l_shoulder,right_front_down,fast),
		turn(Agent,l_elbow,front,fast)]),
		turn_init(Agent,l_hip,front_down1),
		parallel([turn(Agent,r_knee,back,slow),
		turn(Agent,l_knee,back,slow),
		turn(Agent,l_hip,front_down1,slow)]),
		parallel([turn(Agent,l_hip,left_down,slow),
		turn(Agent,l_shoulder,front,slow),
		turn(Agent,r_shoulder,front,slow),
		turn(Agent,l_elbow,down,slow),
		turn(Agent,r_elbow,down,slow),
		turn(Agent,l_knee,down,slow)]),
		parallel([turn(Agent,l_hip,front_down,slow),
		turn(Agent,l_shoulder,front_down,slow),
		turn(Agent,r_shoulder,front_down,slow),
		turn(Agent,l_elbow,front,slow),
		turn(Agent,r_elbow,front,slow),
		turn(Agent,l_knee,back,slow)])
		],
		!.



%high level interaction operator definitions

script(if_then_else(Condition,Then,Else),ActionList):-
		ActionList =[
				 choice([[test(Condition),Then],[test(not(Condition)),Else]])
				],
				!.

script(if_then(Condition,Then),ActionList):-
		ActionList =[
				 choice([[test(Condition),Then],[test(not(Condition)),skip]])
				],
				!.


script(until(Action,Condition),ActionList):-
		ActionList =[
				 [star(Action),test(Condition)]
				],
				!.



	humanoid_objects(true).

	getBodyObjectName(Humanoid,Part,Reference) :-
		humanoid_objects(true),
		getSFNode(Humanoid,Part,Reference),
		%%format('accessing ~w.~w : ~w~n',[Humanoid,Part,Reference]),
		!.


	getBodyName(l_shoulder,l_shoulder) :- !.
	getBodyName(r_shoulder,r_shoulder) :- !.
	getBodyName(l_elbow,l_elbow) :- !.
	getBodyName(r_elbow,r_elbow) :- !.
	getBodyName(l_hip,l_hip) :- !.
	getBodyName(r_hip,r_hip) :- !.
	getBodyName(l_ankle,l_ankle) :- !.
	getBodyName(r_ankle,r_ankle) :- !.
	getBodyName(l_knee,l_knee) :- !.
	getBodyName(r_knee,r_knee) :- !.
	getBodyName(l_wrist,l_wrist) :- !.
	getBodyName(r_wrist,r_wrist) :- !.
	getBodyName(vl5,vl5) :- !.
	getBodyName(skullbase,skullbase) :- !.
	getBodyName(humanoidroot,humanoidroot) :- !.
	getBodyName(sacroiliac,sacroiliac) :- !.



	getBodyObjectName(humanoid,l_shoulder,hanim_l_shoulder) :- !.
	getBodyObjectName(humanoid,r_shoulder,hanim_r_shoulder) :- !.
	getBodyObjectName(humanoid,l_elbow,hanim_l_elbow) :- !.
	getBodyObjectName(humanoid,r_elbow,hanim_r_elbow) :- !.
	getBodyObjectName(humanoid,l_hip,hanim_l_hip) :- !.
	getBodyObjectName(humanoid,r_hip,hanim_r_hip) :- !.
	getBodyObjectName(humanoid,l_ankle,hanim_l_ankle) :- !.
	getBodyObjectName(humanoid,r_ankle,hanim_r_ankle) :- !.
	getBodyObjectName(humanoid,l_knee,hanim_l_knee) :- !.
	getBodyObjectName(humanoid,r_knee,hanim_r_knee) :- !.
	getBodyObjectName(humanoid,l_wrist,hanim_l_wrist) :- !.
	getBodyObjectName(humanoid,r_wrist,hanim_r_wrist) :- !.
	getBodyObjectName(humanoid,vl5,hanim_vl5) :- !.
	getBodyObjectName(humanoid,skullbase,hanim_skullbase) :- !.
	getBodyObjectName(humanoid,humanoidroot,hanim_HumanoidRoot) :- !.
	getBodyObjectName(humanoid,sacroiliac,hanim_sacroiliac) :- !.

	getBodyObjectName(H, B, N) :-
		format('invalid name : H=~w, B=~w, N=~w~n', [H,B,N]).
	object_class(l, l_shoulder) :- !.
	object_class(r, r_shoulder) :- !.
	object_class(l, l_elbow) :- !.
	object_class(r, r_elbow) :- !.
	object_class(l, l_hip) :- !.
	object_class(r, r_hip) :- !.
	object_class(l, l_ankle) :- !.
	object_class(r, r_ankle) :- !.
	object_class(l, l_knee) :- !.
	object_class(r, r_knee) :- !.
	object_class(l, l_wrist) :- !.
	object_class(r, r_wrist) :- !.
	object_class(c,vl5) :- !.
	object_class(c,skullbase) :- !.
	object_class(c,root) :- !.
	object_class(c,sacroiliac) :- !.
	object_class(c,humanoidroot) :- !.
	object_class(C, B) :-
		format('object class error : C=~w, B=~w~n', [C,B]).
	getRotationParameter(_Object,rotation(X,Y,Z,R0),rotation(X,Y,Z,R0)):-
		!.
	
	getRotationParameter(Object,Direction,R):-
		object_class(ObjectClass,Object),
		rotation_parameter(ObjectClass,Direction,R),
		!.
	getRotationParameter(Object,_Poser,_R):-
		format('rotation parameter error for ~w~n', [Object]).
	
	
	rotation_parameter(l, front, rotation(1.0,0.0,0.0,-1.57)):-!.
	rotation_parameter(l, back, rotation(1.0,0.0,0.0,1.57)):-!.
	rotation_parameter(l, back_down2, rotation(1.0,0.0,0.0,0.4)):-!.
	rotation_parameter(l, front_down2, rotation(1.0,0.0,0.0,-0.4)):-!.
	rotation_parameter(l, back_down, rotation(1.0,0.0,0.0,0.77)):-!.
	rotation_parameter(l, back2_down, rotation(1.0,0.0,0.0,1.17)):-!.
	rotation_parameter(l, front_down, rotation(1.0,0.0,0.0,-0.77)):-!.
	rotation_parameter(l, front_down1, rotation(1.0,0.0,0.0,-1.37)):-!.
	rotation_parameter(l, back_up, rotation(1.0,0.0,0.0,-2.34)):-!.
	rotation_parameter(l, front_up, rotation(1.0,0.0,0.0,2.34)):-!.
	rotation_parameter(l, up_via_back, rotation(1.0,0.0,0.0,3.14)):-!.
	rotation_parameter(l, up, rotation(1.0,0.0,0.0,-3.14)):-!.
	rotation_parameter(l, turn_90, rotation(0.0,1.0,0.0,1.57)):-!.
	rotation_parameter(l, turn_n90, rotation(0.0,1.0,0.0,-1.57)):-!.
	rotation_parameter(l, turn_45, rotation(0.0,1.0,0.0,0.79)):-!.
	rotation_parameter(l, turn_n45, rotation(0.0,1.0,0.0,-0.79)):-!.
	rotation_parameter(l, turn_180, rotation(0.0,1.0,0.0,3.14)):-!.
	rotation_parameter(l, turn_n180, rotation(0.0,1.0,0.0,-3.14)):-!.
	rotation_parameter(l, turn_270, rotation(0.0,1.0,0.0,4.71)):-!.
	rotation_parameter(l, turn_n270, rotation(0.0,1.0,0.0,-4.71)):-!.
	rotation_parameter(l, turn_360, rotation(0.0,1.0,0.0,6.28)):-!.
	rotation_parameter(l, turn_n360, rotation(0.0,1.0,0.0,-6.28)):-!.
	rotation_parameter(l, turn_reset, rotation(0.0,1.0,0.0,0.0)):-!.
	rotation_parameter(l, front_right, rotation(1.0,1.0,0.0,-1.57)):-!.
	rotation_parameter(l, front_right2, rotation(1.0,1.0,0.0,-1.3)):-!.
	rotation_parameter(l, front_right1, rotation(1.0,1.0,0.0,-1.0)):-!.
	rotation_parameter(l, back_down_turn_90, rotation(1.0,1.0,0.0,1.57)):-!.
	rotation_parameter(l, left_back_down_turn_90, rotation(0.0,1.0,1.0,1.57)):-!.
	rotation_parameter(l, right_back_down_turn_n90, rotation(0.0,1.0,1.0,-1.57)):-!.
	rotation_parameter(l, left_front_down_turn_90, rotation(0.0,1.0,1.0,1.57)):-!.
	rotation_parameter(l, left_front_down, rotation(-0.97,0.09,0.23,0.79)):-!.
	rotation_parameter(l, right_front_down, rotation(-0.37,-0.86,0.35,1.13)):-!.
	rotation_parameter(l, down, rotation(0.0,0.0,1.0,0.0)):-!.
	rotation_parameter(l, down_from_front, rotation(1.0,0.0,0.0,0.0)):-!.
	rotation_parameter(l, up_via_center,rotation(0.0,0.0,1.0,3.14)):-!.
	rotation_parameter(l, up_via_right,rotation(0.0,0.0,1.0,3.14)):-!.
	rotation_parameter(l, up_via_side,rotation(0.0,0.0,1.0,-3.14)):-!.
	rotation_parameter(l, up_via_left,rotation(0.0,0.0,1.0,-3.14)):-!.
	rotation_parameter(l, side_up, rotation(0.0,0.0,1.0,2.34)):-!.
	rotation_parameter(l, side, rotation(0.0,0.0,1.0,1.57)):-!.
	rotation_parameter(l, left_up, rotation(0.0,0.0,1.0,2.34)):-!.
	rotation_parameter(l, left, rotation(0.0,0.0,1.0,1.57)):-!.
	rotation_parameter(l, side_down, rotation(0.0,0.0,1.0,0.77)):-!.
	rotation_parameter(l, left_down, rotation(0.0,0.0,1.0,0.77)):-!.
	rotation_parameter(l, side2_down, rotation(0.0,0.0,1.0,0.38)):-!.
	rotation_parameter(l, left2_down, rotation(0.0,0.0,1.0,0.38)):-!.
	rotation_parameter(l, side1_down, rotation(0.0,0.0,1.0,0.19)):-!.
	rotation_parameter(l, left1_down, rotation(0.0,0.0,1.0,0.19)):-!.
	rotation_parameter(l, center_up, rotation(0.0,0.0,1.0,-2.34)):-!.
	rotation_parameter(l, right_up, rotation(0.0,0.0,1.0,-2.34)):-!.
	rotation_parameter(l, left_front2_up, rotation(-1.0,0.0,1.0,2.34)):-!.
	rotation_parameter(l, left_front_up2, rotation(-1.0,0.0,1.0,1.57)):-!.
	rotation_parameter(l, side_front2_up, rotation(-1.0,0.0,1.0,2.34)):-!.
	rotation_parameter(l, side_front_up2, rotation(-1.0,0.0,1.0,1.57)):-!.
	rotation_parameter(l, left_front_up, rotation(-0.38,-0.16,0.91,2.4)):-!.
	rotation_parameter(l, side_front_up, rotation(-0.38,-0.16,0.91,2.4)):-!.
	rotation_parameter(l, up_turn_n90, rotation(-0.71,0,-0.71,3.14)):-!.
	rotation_parameter(l, up_turn_90, rotation(-0.71,0,0.71,3.14)):-!.
	rotation_parameter(l, front_turn_90, rotation(-0.58,0.58,-0.58,2.0)):-!.
	rotation_parameter(l, center, rotation(0.0,0.0,1.0,-1.57)):-!.
	rotation_parameter(l, right, rotation(0.0,0.0,1.0,-1.57)):-!.
	rotation_parameter(l, center_down, rotation(0.0,0.0,1.0,-0.77)):-!.
	rotation_parameter(l, right_down, rotation(0.0,0.0,1.0,-0.77)):-!.
	
	
	
	
	rotation_parameter(r, front,rotation(1.0,0.0,0.0,-1.57)):-!.
	rotation_parameter(r, back,rotation(1.0,0.0,0.0,1.57)):-!.
	rotation_parameter(r, front_down2, rotation(1.0,0.0,0.0,-0.4)):-!.
	rotation_parameter(r, back_down2, rotation(1.0,0.0,0.0,0.4)):-!.
	rotation_parameter(r, back2_down, rotation(1.0,0.0,0.0,1.17)):-!.
	rotation_parameter(r, front_down, rotation(1.0,0.0,0.0,-0.77)):-!.
	rotation_parameter(r, front_down1, rotation(1.0,0.0,0.0,-1.37)):-!.
	rotation_parameter(r, back_down, rotation(1.0,0.0,0.0,0.77)):-!.
	rotation_parameter(r, up_via_back, rotation(1.0,0.0,0.0,3.14)):-!.
	rotation_parameter(r, up, rotation(1.0,0.0,0.0,-3.14)):-!.
	rotation_parameter(r, turn_90, rotation(0.0,1.0,0.0,1.57)):-!.
	rotation_parameter(r, turn_n90, rotation(0.0,1.0,0.0,-1.57)):-!.
	rotation_parameter(r, turn_45, rotation(0.0,1.0,0.0,0.79)):-!.
	rotation_parameter(r, turn_n45, rotation(0.0,1.0,0.0,-0.79)):-!.
	rotation_parameter(r, turn_180, rotation(0.0,1.0,0.0,3.14)):-!.
	rotation_parameter(r, turn_n180, rotation(0.0,1.0,0.0,-3.14)):-!.
	rotation_parameter(r, turn_270, rotation(0.0,1.0,0.0,4.71)):-!.
	rotation_parameter(r, turn_n270, rotation(0.0,1.0,0.0,-4.71)):-!.
	rotation_parameter(r, turn_360, rotation(0.0,1.0,0.0,6.28)):-!.
	rotation_parameter(r, turn_n360, rotation(0.0,1.0,0.0,-6.28)):-!.
	rotation_parameter(r, turn_reset, rotation(0.0,1.0,0.0,0.0)):-!.
	rotation_parameter(r, front_right, rotation(1.0,1.0,0.0,-1.57)):-!.
	rotation_parameter(r, front_left, rotation(-1.0,1.0,0.0,1.57)):-!.
	rotation_parameter(r, front_left2, rotation(-1.0,1.0,0.0,1.3)):-!.
	rotation_parameter(r, front_left1, rotation(-1.0,1.0,0.0,1.00)):-!.
	rotation_parameter(r, back_down_turn_90, rotation(1.0,1.0,0.0,1.57)):-!.
	rotation_parameter(r, left_back_down_turn_90, rotation(0.0,1.0,1.0,1.57)):-!.
	rotation_parameter(r, right_back_down_turn_n90, rotation(0.0,1.0,1.0,-1.57)):-!.
	rotation_parameter(r, left_front_down_turn_90, rotation(-1.0,1.0,0.0,1.57)):-!.
	rotation_parameter(r, down,rotation(0.0,0.0,1.0,0.0)):-!.
	rotation_parameter(r, down_from_front, rotation(1.0,0.0,0.0,0.0)):-!.
	rotation_parameter(r, up_via_side,rotation(0.0,0.0,1.0,3.14)):-!.
	rotation_parameter(r, up_via_left,rotation(0.0,0.0,1.0,3.14)):-!.
	rotation_parameter(r, up_via_center,rotation(0.0,0.0,1.0,-3.14)):-!.
	rotation_parameter(r, up_via_left,rotation(0.0,0.0,1.0,-3.14)):-!.
	rotation_parameter(r, side_up,rotation(0.0,0.0,1.0,-2.34)):-!.
	rotation_parameter(r, side,rotation(0.0,0.0,1.0,-1.57)):-!.
	rotation_parameter(r, right_up,rotation(0.0,0.0,1.0,-2.34)):-!.
	rotation_parameter(r, right,rotation(0.0,0.0,1.0,-1.57)):-!.
	rotation_parameter(r, side_down, rotation(0.0,0.0,1.0,-0.77)):-!.
	rotation_parameter(r, right_down, rotation(0.0,0.0,1.0,-0.77)):-!.
	rotation_parameter(r, side2_down, rotation(0.0,0.0,1.0,-0.38)):-!.
	rotation_parameter(r, left2_down, rotation(0.0,0.0,1.0,-0.38)):-!.
	rotation_parameter(r, side1_down, rotation(0.0,0.0,1.0,-0.19)):-!.
	rotation_parameter(r, left1_down, rotation(0.0,0.0,1.0,-0.19)):-!.	
	rotation_parameter(r, center, rotation(0.0,0.0,1.0,1.57)):-!.
	rotation_parameter(r, left, rotation(0.0,0.0,1.0,1.57)):-!.
	rotation_parameter(r, center_down, rotation(0.0,0.0,1.0,0.77)):-!.
	rotation_parameter(r, left_down, rotation(0.0,0.0,1.0,0.77)):-!.
	rotation_parameter(r, center_up, rotation(0.0,0.0,1.0,2.34)):-!.
	rotation_parameter(r, left_up, rotation(0.0,0.0,1.0,2.34)):-!.
	rotation_parameter(r, right_front2_up, rotation(-1.0,0.0,-1.0,2.34)):-!.
	rotation_parameter(r, right_front_up2, rotation(-1.0,0.0,-1.0,1.57)):-!.
	rotation_parameter(r, right_front_down, rotation(-0.97,-0.09,-0.23,0.79)):-!.
%	rotation_parameter(r, left_front_down, rotation(0.97,-0.09,-0.23,0.79)):-!.
	rotation_parameter(r, side_front2_up, rotation(-1.0,0.0,-1.0,2.34)):-!.
	rotation_parameter(r, side_front_up2, rotation(-1.0,0.0,-1.0,1.57)):-!.
	rotation_parameter(r, right_front_up, rotation(-0.38,0.16,-0.91,2.4)):-!.
	rotation_parameter(r, side_front_up, rotation(-0.38,0.16,-0.91,2.4)):-!.
	rotation_parameter(r, up_turn_n90, rotation(-0.71,0,0.71,3.14)):-!.
	rotation_parameter(r, up_turn_90, rotation(-0.71,0,-0.71,3.14)):-!.
	
	rotation_parameter(r, front_turn_90, rotation(-0.58,-0.58,0.58,2.0)):-!.
	
	rotation_parameter(r, back_up, rotation(1.0,0.0,0.0,2.34)):-!.
	rotation_parameter(r, side_up2, rotation(1.0,0.0,0.0,-2.34)):-!.
	rotation_parameter(r, right_up2, rotation(1.0,0.0,0.0,-2.34)):-!.
	rotation_parameter(c, right, rotation(0.0,0.0,1.0,1.47)):-!.
	rotation_parameter(c, up, rotation(1.0,0.0,0.0,-1.57)):-!.
	rotation_parameter(c, right_down, rotation(0.0,0.0,1.0,3.00)):-!.
	rotation_parameter(c, left_down, rotation(0.0,0.0,1.0,-3.00)):-!.
	rotation_parameter(c, down, rotation(1.0,0.0,0.0,1.57)):-!.
	rotation_parameter(c, left_turn, rotation(0.0,1.0,0.0,1.57)):-!.
	rotation_parameter(c, right_turn, rotation(0.0,1.0,0.0,-1.57)):-!.
	rotation_parameter(c, front, rotation(0.0,0.0,1.0,0.0)):-!.
	rotation_parameter(c, right_down2, rotation(0.0,0.0,1.0,2.34)):-!.
	rotation_parameter(c, left_down2, rotation(0.0,0.0,1.0,-2.34)):-!.
	rotation_parameter(c, left_down1, rotation(0.0,0.0,1.0,-1.57)):-!.
	rotation_parameter(c, right_down1, rotation(0.0,0.0,1.0,1.57)):-!.
	rotation_parameter(c, front_down2, rotation(1.0,0.0,0.0,0.4)):-!.
	rotation_parameter(c, front_up2, rotation(1.0,0.0,0.0,-0.4)):-!.
	rotation_parameter(c, front_down, rotation(1.0,0.0,0.0,0.77)):-!.
	rotation_parameter(c, front_up, rotation(1.0,0.0,0.0,-0.77)):-!.
	rotation_parameter(c, back_up, rotation(1.0,0.0,0.0,-2.34)):-!.
	rotation_parameter(c, front_down3, rotation(1.0,0.0,0.0,2.34)):-!.
	rotation_parameter(c, front_left_down, rotation(1.0,1.0,0.0,0.77)):-!.
	rotation_parameter(c, front_right_up, rotation(1.0,1.0,0.0,-0.77)):-!.
	rotation_parameter(c, front_right_down, rotation(1.0,0.0,1.0,0.77)):-!.
	rotation_parameter(c, front_left_up, rotation(1.0,0.0,1.0,-0.77)):-!.
	rotation_parameter(c, front_left_up_turn, rotation(0.0,1.0,1.0,0.77)):-!.
	rotation_parameter(c, front_left_down_turn, rotation(0.0,1.0,1.0,-0.77)):-!.
	rotation_parameter(c, turn_22, rotation(0.0,1.0,0.0,0.38)):-!.
	rotation_parameter(c, turn_n22, rotation(0.0,1.0,0.0,-0.38)):-!.
	rotation_parameter(c, turn_45, rotation(0.0,1.0,0.0,0.79)):-!.
	rotation_parameter(c, turn_n45, rotation(0.0,1.0,0.0,-0.79)):-!.
	rotation_parameter(c, turn_90, rotation(0.0,1.0,0.0,1.57)):-!.
	rotation_parameter(c, turn_n90, rotation(0.0,1.0,0.0,-1.57)):-!.
	rotation_parameter(c, turn_180, rotation(0.0,1.0,0.0,3.14)):-!.
	rotation_parameter(c, turn_n180, rotation(0.0,1.0,0.0,-3.14)):-!.
	rotation_parameter(c, turn_270, rotation(0.0,1.0,0.0,4.71)):-!.
	rotation_parameter(c, turn_n270, rotation(0.0,1.0,0.0,-4.71)):-!.
	rotation_parameter(c, turn_360, rotation(0.0,1.0,0.0,6.28)):-!.
	rotation_parameter(c, turn_n360, rotation(0.0,1.0,0.0,-6.28)):-!.
	rotation_parameter(c, turn_reset, rotation(0.0,1.0,0.0,0.0)):-!.
%	rotation_parameter(c, left_front2_up, rotation(-1.0,0.0,1.0,2.34)):-!.
%	rotation_parameter(c, left_front_up2, rotation(-1.0,0.0,1.0,1.57)):-!.
%	rotation_parameter(c, side_front2_up, rotation(-1.0,0.0,1.0,2.34)):-!.
%	rotation_parameter(c, side_front_up2, rotation(-1.0,0.0,1.0,1.57)):-!.
%	rotation_parameter(c, left_front_up, rotation(-0.38,-0.16,0.91,2.4)):-!.
	rotation_parameter(c, right_front_up, rotation(0.38,-0.16,0.91,0.4)):-!.
	rotation_parameter(c, right_back_down, rotation(-0.38,-0.16,0.91,2.4)):-!.
	rotation_parameter(c, right_front_down, rotation(0.38,0.16,0.91,2.4)):-!.
	rotation_parameter(c, left_back_up, rotation(0.38,-0.16,-0.91,0.4)):-!.
	rotation_parameter(c, right_back_up, rotation(0.38,-0.16,-0.91,-0.4)):-!.
	rotation_parameter(c, right_front_up2, rotation(1.0,1.0,1.0,0.1)):-!.


	rotation_parameter(C, Po, R):-
		format('rotation error : C=~w, Po=~w, R=~w~n', [C,Po,R]).
	position_parameter(c, front, increment(0.0,0.0,0.7)):-!.
	position_parameter(c, back, increment(0.0,0.0,-0.7)):-!.
	position_parameter(c, left, increment(0.7,0.0,0.0)):-!.
	position_parameter(c, right, increment(-0.7,0.0,0.0)):-!.
	position_parameter(c, up, increment(0.0,0.5,0.0)):-!.
	position_parameter(c, down, increment(0.0,-0.5,0.0)):-!.
	position_parameter(C, Po, P):-
		format('position error : C=~w, Po=~w, P=~w~n', [C,Po,P]).
	getPositionParameter(_Object,increment(X,Y,Z),increment(X,Y,Z)):-
	!.
	getPositionParameter(Object,Direction,Position):-
		object_class(ObjectClass,Object),
		position_parameter(ObjectClass,Direction,Position).
	getSpeedParameter(_Object,beat(Beat),Beat,Interpolation):-
		Interpolation is unit_interpolation * Beat,
		!.
	getSpeedParameter(_Object,time(Time,second),Beat,Interpolation):-
%		Beat is Time*tempo/60.0,
		Beat is Time,
		Interpolation is unit_interpolation * Beat,
		!.
	
	getSpeedParameter(Object,Speed,Beat,Interpolation):-
		object_class(ObjectClass,Object),
		speed_parameter(ObjectClass,Speed,Beat),
		Interpolation is unit_interpolation * Beat,
		!.
	getSpeedParameter(Object, _Speed, _Beat, _Interpolation):-
		format('speed parameter error for ~w~n', [Object]).
	speed_parameter(l, slow, 3):-!.
	speed_parameter(l, very_slow, 5):-!.
	speed_parameter(l, intermedia, 2):-!.
	speed_parameter(l, fast, 1):-!.
	speed_parameter(l, very_fast, 0.5):-!.
	speed_parameter(r, slow, 3):-!.
	speed_parameter(r, very_slow, 5):-!.
	speed_parameter(r, intermedia, 2):-!.
	speed_parameter(r, fast, 1):-!.
	speed_parameter(r, very_fast, 0.5):-!.
	speed_parameter(c, slow, 3):-!.
	speed_parameter(c, very_slow, 5):-!.
	speed_parameter(c, intermedia, 2):-!.
	speed_parameter(c, fast, 1):-!.
	speed_parameter(c, very_fast, 0.5):-!.
	speed_parameter(C, S, T):-
		format('spped error : C=~w, S=~w, T=~w~n', [C,S,T]).
:-end_object gesturelib.





:-object steps : [ browser, step, bcilib, do_script, gesturelib].

	jump :-
		%% text_area(Browser),
		%% set_output(Browser),
		format('taking steps~n'),
		sleep(500),
%		set_field(tempo, 60.0),
		script_threads,
%		process_gesture_script(get_adjustY(humanoid,Y)),
%		repeat_gesture_script(walk_adjustY(humanoid,0.3,0.7),5),
		process_script(jump(humanoid)),
		true.
	xtaichi :-
		format('practice tai chi~n'),
		%%getMFNode(humanoid,joints,R),
		%%getMFNode(layer,choice,R),
		getSFNode(humanoid,l_hip,R),
		format('node: ~w~n',[R]),
		%%format('rotation ~w ~w ~w ~w~n',[X,Y,Z,R]),
		process_script(taichi(humanoid)),
		true.
	taichi :-
		format('practice tai chi~n'),
		%%sleep(100),
		setfm(humanoid,string,'Ok, pay~nclose attention'),
		set_field(tempo, 120.0),
		script_threads,
		setfm(humanoid,string,''),
		process_script(taichi(humanoid)),
		setfm(humanoid,string,''),
		true.


:-end_object steps.







:- object gestures : [ parameters, objects, soccer, steps ].
var max=12.



action(P,D,T,N,L,kick) :- !, kick.
action(P,D,T,N,L,step) :- !, step.
action(P,D,T,N,L,jump) :- !, jump.
action(P,D,T,N,L,taichi) :- !, taichi.
action(P,D,T,N,L,steps(X)) :- !, new(steps(X)).
action(P,D,T,N,L,deposit) :- !, deposit(P,T).
action(P,D,T,N,L,A) :- !, fail.



:- end_object gestures.



:- object phrases : [gestures]. 
initial_phrase(monitor,'DEMO'):- !,do_action(r,f,0,'this',0,begin(monitor)).
initial_phrase(right,'     d~n     i~n     a'):- !,do_action(r,f,0,'this',0,begin(right)).
initial_phrase(left,'logs?'):- !,do_action(r,f,0,'this',0,begin(left)).
phrase(r,f,0,'step-tai-chi',0,S,0,500):- !,do_action(r,f,0,'step-tai-chi',0,[p=(0.8,0,0),default]),fm(S,'do some~ntai chi',[]).
gesture(r,f,0,'step-tai-chi',0,3):- !,do_action(r,f,0,'step-tai-chi',0,[humanoid=text(0,0,0),humanoid=balloon(0),humanoid=string('tai chi?')]).
phrase(l,f,0,'step-tai-chi',0,S,0,500):- !,do_action(l,f,0,'step-tai-chi',0,[p=(-1.0,0,0),taichi,next('demo-taichi'),default,p(b)=(0.5,0,1),persona=0,balloon=0]),fm(S,'great!',[]).
phrase(r,f,0,'step-tai-chi',1,S,0,500):- !,!,fm(S,'well done',[]).
gesture(r,f,0,'step-tai-chi',1,1):- !,do_action(r,f,0,'step-tai-chi',1,[humanoid=type(2),humanoid=string('thank you')]).
phrase(l,f,0,'step-tai-chi',1,S,0,500):- !,do_action(l,f,0,'step-tai-chi',1,[a(e)=1,humanoid=string(''),humanoid=visible(-1)]),fm(S,'what s next?',[]).
phrase(r,f,1,'step-tai-chi',1,S,0,500):- !,do_action(r,f,1,'step-tai-chi',1,[a(e)=1,next('demo-taichi')]),fm(S,'kung fu?',[]).
phrase(r,b,0,_,_,S,0,500):- !,!,fm(S,'haven t~nI seen this~nbefore?',[]).
phrase(l,b,0,_,_,S,0,500):- !,!,fm(S,'I am glad~nyou re paying~nattention!!',[]).
gesture(r,b,_,_,_,0):- !,!.
pause(r,b,_,_,_) :- !, delay(500).
gesture(l,b,_,_,_,0):- !,!.
pause(l,b,_,_,_) :- !, delay(600).
gesture(r,f,_,_,_,0):- !,!.
pause(r,f,_,_,_) :- !, delay(500).
gesture(l,f,_,_,_,0):- !,!.
pause(l,f,_,_,_) :- !, delay(500).
:- end_object phrases.













:- object dialog : [ phrases ].

var turn = 0.

xxdialog(_) :-
   repeat,
     accept(any),
   fail.

act(D,N,L) :- !,
	turn := -1,
	format('act ~w (~w)~n',[N,L]),
	fm(S,'~w (~w)',[N,L]),
	set(monitor,string,mfstring(S)),
	process(D,N,L).

process(D,N,L) :- 
	repeat,
	++turn,
	right(D,turn,N,L),
	left(D,turn,N,L),
	turn == -1.

process(_,_,_).





right(D,T,N,L) :-
	phrase(r,D,T,N,L,X,M,W),!,
	beginUpdate,
	pre_right(M),
	set(right,string,mfstring(X)),
	endUpdate,
	do_gesture(right,r,D,T,N,L),
	%%pause(r,D,T,N,L),
	delay(W),
	beginUpdate,
	post_right(M),
	endUpdate,
	!.
right(_,_,_,_).

left(D,T,N,L) :-
	phrase(l,D,T,N,L,X,M,W),!,
	beginUpdate, %% rotation int -> float
	pre_left(M),
	set(left,string,mfstring(X)),
	endUpdate,
	do_gesture(left,l,D,T,N,L),
	%%pause(l,D,T,N,L),
	delay(W),
	beginUpdate,
	post_left(M),
	endUpdate,
	!.

left(_,_,_,_) :- turn := -1.


do_gesture(O,P,D,T,N,L) :-
  gesture(P,D,T,N,L,X),
  not(X = 0),  !,
  format('gesture ~w(~w-~w): ~w (~w) [~w] ~n',[P,D,T,N,L,X]),
  set(O,gesture,sfint32(X)).

do_gesture(_,_,_,_,_,_) :-
  format('no gesture~n').

:- end_object dialog.






:- object observer : [dialog].

var slide = anonymous.
var lev = 0.
var comment.
var v_projector.

observer(X) :- 
	comment := this,  %% self or this ??
	format('observer started: ~w~n',[X]),
	v_projector := X,
	set_defaults(style),
	%% comment := new(dialog),
	%%observe(slideset,update,O),
	%%observe(slideset,id,O),
	%%observe(slideset,level,O),
	repeat,
	 accept(
	 id(_V,_T,_N),
	 level(_V,_T,_N),
	 update(_V,_T,_N),
	 touched(_V,_T,_N)
	 ),
	 fail.

id(V,_T,_N) :- format('id ~w~n',[V]), !, slide := V.
level(V,_T,_N) :- lev := V.

touched(V,T,_N) :-
	format('event touched: ~w (~w) ~n',[V,T]),	
	v_projector->touched(V,T,_N),
	%%process(V),
	format('end event touched: ~w (~w) ~n',[V,T]).	

update(V,T,_N) :- !,
	format('event update: ~w (~w) ~n',[V,T]),	
	process(V),!,
	format('end event update: ~w (~w) ~n',[V,T]),!.	

process(1) :- !,
	%%get(slideset,id,sfstring(N)),
	%%format('process 1: ~w (~w) ~n',[N,0]),	
	%%slide := N,
	%%comment->act(f,slide,lev). 
	act(f,slide,lev). 

process(2) :- !,
	%%get(slideset,level,sfint32(L)),
	%%format('process 2: ~w (~w) ~n',[slide,L]),	
	act(f,slide,lev).

process(3) :- !,
	%%get(slideset,id,sfstring(N)),
	%%get(slideset,level,sfint32(L)),
	%%format('process 3: ~w (~w) ~n',[N,L]),	
	%%slide := N,
	act(b,slide,lev). 

process(4) :- !,
	%%get(slideset,level,sfint32(L)),
	%%format('process 4: ~w (~w) ~n',[slide,L]),	
	!.
	%%act(b,slide,lev).


process(X) :- !,
	format('process ??: --~w-- ~n',[X]),	
	!.



:- end_object observer.








:- object projector : [browser].
var slideset.
var stop = 0.

projector(X):-
	slideset := X,
	repeat,
	accept(
	%%update(_,_,_),
	touched(_V,_T,_N)
	),
	fail.

touched(V,T,_N) :- !,
	format('projector::touch ~w (~w)~n',[V,T]),
	process(V),
	format('end projector::touch ~w (~w)~n',[V,T]).

process(1) :- !,
       move_slides(_).
process(_) :- !.

move_slides(_) :-
        repeat,
           set(slideset,next,sftime(0.0)),
	   %%report(N,L),
           pause(N,L),
         stop == -1.

pause(_,_) :- !, delay(60000).

report(_,_) :- !, format('project: next slide',[]).
xreport(N,L):- !, 
		get(slideset,id,sfstring(N)),
		%%get(slideset,number,sfint32(N)),
		get(slideset,level,sfint32(L)),
		!.
		%%get(slideset,direction,sfstring(Dir)),
		%%format('~w: ~w-~w ~w  (~w)~n',[S,N,L,Id,Dir]).

:- end_object projector.






:- object slides : [browser,phrases].

var v_observer.
var v_slides.
var v_projector.

next :-
	set(v_slides,next,sftime(0.0)).

get_phrase(P,S) :-
	initial_phrase(P,S),!.
get_phrase(_,'').

set_phrase(P) :-
	get_phrase(P,S),
	setfm(P,string,S).

initialize :- !,
	set_phrase(monitor),
	set_phrase(right),
	set_phrase(left),

	set(left,visible,sfint32(0)),
	set(right,visible,sfint32(0)),
	!.

connect(I) :-
       format('connecting ~w~n',[I]),
       set(I,dlp,sfint32(1)),
       observe(v_slides,touched,v_projector).        
                                      
watch(Slides) :- watch(Slides,_).

watch(Slides,O) :-
       P := new(projector(Slides)),
       O := new(observer(P)),  
       v_projector := P,
       v_observer := O,
       v_slides := Slides,
       observe(Slides,update,O),    
       observe(Slides,id,O),        
       observe(Slides,level,O).     

:- end_object slides.






:-object object_demo_taichi : [slides].

var url = '@talk-demo-taichi.wrl'.
var slideset = 'demo-taichi'.
var interface = 'demo-taichi-interface'.

main :-
	load(url),
	delay(5000),
	
	initialize,

	watch(slideset),
	connect(interface),

	delay(2000),
	!.

:- end_object object_demo_taichi.  



