<?vrml style=eca>
<document type=eca>
%%with-pdf with-dlp with-wrl
@cite=2
<c><p align=right><a href=@text-paper-eca.pdf>PDF</a></p></c>
<include file=@biblio/keys>
<so abstract-eca>

%%<channel color=blue a=0.2 text=white x=8 y=-2 scale="1.7 1.4 1" text=white>
<l>\def\thepage{}</l>

@* Introduction

Embodied conversational agents may be regarded
as a merge of technology resulting from research
in artificial intelligence (agent technology)
and computer graphics (humanoid animation).
A wellknown example is the <url href=http://www.ananova.com>Ananova</url>
virtual newscaster, that presents the latest news in so-called
<em>video reports</em>, that are created using "<em>a unique
combination of computer animation, text-to-speech and real-time 
information systems</em>".
<lp>
Other applications of embodied conversational agents
include
the <em><url href=http://www.signingavatar.com>Signing Avatar</url></em>,
(a system that allows for translating arbitrary text in
sign language for the deaf),
talking heads in a variety of e-commerce applications,
and the agent-bots
in virtual environments
such as <url href=http://www.activeworlds.com>Active Worlds</url>,
<url href=http://www.blaxxun.com><em>blaxxun</em> Community</url>
and <url href=http://www.adobe.com/products/atmosphere>Adobe Atmosphere</url>.
<lp>
Clearly, there is such a great diversity of systems
in which embodied conversational agents play a role,
for which it is not always easy to establish how essential
the agent's contribution is, that it is hard to find the
common denominator of ECA applications.
Our view of what embodied conversational agents should
provide is summarized in the five propositions below:
<slide id=eca-propose>
<c>
/// propositions
</c>
<small>
<ul>
<li> proposition 1: agents need content</li>
<li> proposition 2: agents must provide added value</li>
<li> proposition 3: gestures and (facial) animation must be meaningful</li>
<li> proposition 4: agents should be naturally embedded in their environment</li>
<li> proposition 5: the behavior of agents must be understandable</li>
</ul>
</small>
<navigate/>
</slide>
Although, admittedly, a direct translation of these assumptions
to system requirements 
is not feasible, the central idea that the meaningful application
of embodied agents requires a relevant context has been
a motivating force in developing a declarative platform
with powerful computational features.
<lp>
In addition to the assumptions expressed in the propositions above,
we consider two issues as of relevance for establishing
the merits of a platform supporting embodied conversational
agents, as expressed in the following remarks.
<slide id=eca-remarks>
<c>
/// remarks
</c>
<small>
<ul>
<li> remark 1: the aesthetics of agents should be centered around <em>function</em>, that is form and content</li>
<li> remark 2: developing agents requires intelligent multimedia technology</li>
</ul>
</small>
<navigate>
</slide>
Both remarks purport to the need for a strong notion
of programmability of both the agents appearance and the
(virtual) information world in which the agent lives.
In particular, the second remark is a shameless plug for our own
technology, as presented in this paper.
<lp>
:@ evaluation criteria
There is a wide range of evaluation criteria against
which embodied agent application and systems can be validated.



<c><vrml>
<slide id=pl-eval>
<effect type=style l_persona=-1 r_persona=-1 sky="1 1 1" drop=-1 logo=""/>
<p align=right text=green>evaluation criteria</p>
<p>
<ul>
<li> effective communication </li>
</ul>
/// conversational agents in VR
<ul>
<li> presentational VR, instructional VR, educational VR </li>
</ul>
/// applications
<ul>
<li size=1> information agents, presentation agents </li>
</ul>
/// system perspective 
<ul>
<li> range of agent categories, open standards </li>
</ul>
/// user perspective
<ul>
<li> naturalness  -- contextual &amp; emotional </li>
</ul>
</slide>
</vrml></c>

Evidently,
the primary criterium against which to evaluate
applications that involve embodied conversational
agents is whether the application becomes more effective
by using such agents. Effective, in terms of communication
with the user.
%%Evidently, for the <em>Signing Avatar</em> application this
%%seems to be quite obvious.
%%For other applications, for example negotiation in e-commerce,
%%this question might be more difficult to answer.
<lp>
In a more general fashion, however, we may try to establish
how well particular systems support features that
contribute to the effectiveness of the applications developed 
with them.
<lp>
As concerns, for example, the embedding of conversationl agents in VR,
we might make a distinction between <em>presentational VR</em>,
<em>instructional VR</em> and <em>educational VR</em>.
An example of educational VR is described in [_EducationalVR].
No mention of agents was made in the latter reference though.
In instructional VR, explaining for example the use of a machine,
the appearance of a conversational agent seems to be quite natural.
In presentational VR, however,
the appearance of such agents might be considered as no more 
than a gimmick.
<lp>
Considering the use of agents in applications in general,
we must make a distinction between <em>information agents</em>,
<em>presentation agents</em> and <em>conversational agents</em>.
Although the boundaries between these categories are not clearcut,
there seems to be an increasing degree of interactivity with the user.
<lp>
From a system perspective, we might be interested in what range of 
agent categories the system covers.
Does it provide support for managing information and possibly
information retrieval?
Another issue in this regard could be whether the system
is built around open standards, such as XML and X3D, to allow for
the incorporation of a variety of content.
<lp>
Returning to a user perspective, what seems
to matter most is the naturalness of the (conversational) agents.
This is determined by the graphical quality, as well as
contextual parameters, that is how well the agent is embedded
in its environment.
Equally important are emotive parameters,
that is the mood and style (in gestures and possibly speech)
with which the agents manifest themselves.
In other words, the properties that determine whether
an agent is (really) convincing.
Again, translating such features to system requirements
is hardly feasible.
Yet, it indicates the range of support a platform
for embodied conversational agents should offer.

<c>
<slide color=blue text=white id=pl-structure>
<h4 align=right><orange>structure</green></h4>
<ul bullet=orange size=1.5>
<li>requirements <green>-- guidelines for system design</green> </li>
<li>applications <green> -- target demonstrators</green> </li>
<li>technology <green>-- declarative programming</green> </li>
<li>evaluation<green>-- validation, PEFiC</green></li>
%%<li>related work <green>-- systems, models, encoding</green></li>
<li>conclusions and future research <green>-- digital dossiers</green> </li>
</ul>
<navigate/>
</slide>
</c>


:@ structure 
The structure of this paper is as follows.
In section 2 we will discuss the requirements that
acted as guidelines in developing the platform.
In section 3, we will briefly describe a selected number of
applications that acted as target demonstrators for
our technology.
Section 4 contains a somewhat more detailed description of the
technology on which our platform is built.
And finally, in section 5 we will discuss how to approach
the validation of agent-based applications and address directions for future
research.
As a remark, this paper is based on [_Platform],
and available <url href=http://www.cs.vu.nl/~eliens/papers/title-eca.html>online</url>.

@* Requirements -- guidelines for system design

%%@+ Presentation Platforms

Before we started developing our platform, we had a rather
strong conception of how to approach the software engineering
issues involved, as expressed in [_OO].
We had a clear interest in distributed web applications,
and in particular developing support for 2D and 3D
web agents, as reported in [_WebComputing] and [_Taxonomy].
As our focus turned to VRML-based virtual environments
we adopted VRML as our presentation platform of choice,
due to the availability of (free) browsers and
the convenience of the Java External Authoring Interface.
<lp>
There is a wide range of presentation platforms for embodied
conversational agents.
On one end of the spectrum we have digitized video,
as for example in the early versions of the
Ananova newsreader,
On the other end of the spectrum we have rich media real-time 3D
platforms, as in the aforementioned virtual environments.
<lp>
For both type of systems, advanced authoring tools 
may be used to create content.
In addition, however, for the latter type of
systems also declarative means of modeling may be used
as well as a programmatic interface to create dynamic content.
<lp>
Evidently, from our background,
we have a clear preference for web-based real-time 3D environments
with a strong programmatic interface. In other words,
this excludes systems that rely on offline rendering,
but also systems that rely on the native graphics of a particular
machine.
Also, we rather program the dynamic behavior than create
such behavior using advanced authoring tools.
However, our approach allows for easily incorporating content
produced by these tools. 
Our requirements with respect to a platform supporting such environments
may be summarized as follows.

<slide id=pl-reqs>
<c>
/// <em>programming platform</em>  
</c><p>
<small>
<ul bullet=red size=1.2>
<li><em>declarative language</em> -- for agent support</li>
%%<li><em>programmability</em> -- X3D/VRML EAI support </li>
<li><em>multiple threads of control</em> -- for multiple shared objects</li>
<li><em>distributed communication</em> -- networking capabilities <c>(TCP/IP)</c></li>
</ul>
</small>
%%<effect type=style r_bulb=0 l_bulb=0/>
<phrase level=0 right="Is this where~nDLP~ncomes in?">
<phrase level=0 left="I think so!"/>
<navigate/>
</slide>
\noindent
The first release of our DLP+X3D platform
was used to create agent-based multi-user virtual environments,
deploying a logic-based declarative language
providing  support for intelligent agents.
We have shown in [_Community] that both autonomous agents
and shared objects may be realized using agent-technology
with networking capabilities,
<lp>
:@ scripting behavior  
Now, although a platform as described above offers
powerful computational capabilities, this is clearly
not enough to create embodied conversational agents with
a rich repertoire of gestures.
On top of the DLP+X3D platform, we developed the STEP
scripting language for defining gestures and driving the behavior
of our humanoid agent avatars [_STEP].
<lp>
%%In section 4.3, an outline is given of a gesture
%%scripting language for humanoids based on the H-Anim 1.1 standard.
The design of the scripting language was motivated by
the requirements listed below.

<slide id=pl-principle>
<c>
/// <em>scripting behavior</em>
<p>
</c>
<small>
<ul bullet=blue>
<li><em>convenience</em> -- for non-professional authors </li>
<li><em>compositional semantics</em> -- combining operations </li>
<li><em>re-definability</em> -- for high-level specification of actions </li>
<li><em>parametrization</em> -- for the adaptation of actions </li>
<li><em>interaction</em> -- with a (virtual) environment </li>
</ul>
</small>
<navigate/>
</slide>
\noindent
STEP is based on dynamic logic [_DL] and allows
for arbitrary abstractions using the primitives and
composition operators provided by our logic.
<lp>
The rationale underlying STEP is rather different than
found in approaches relying on animation tools or low level
scripting languages.
STEP offers the means to model complex gestures on a very high level
in a purely declarative fashion, using the primitives and
compound operators in more detail described in section 4.2.

@* Applications -- target demonstrators

In the course of developing our platform, we repeatedly shifted
focus depending on our interests at the time.
We started out with developing 
a soccer game, that allowed (multiple) users and autonomous agents to interact
in a 3D environment.
Over time, we had a steady, and very practically motivated,
interest in presentational VR, including the use of 
agent avatars commenting on the material presented.
However, the true focus of our work has become our
STEP scripting language, which has been extended over time
to include both gesture and facial animation, as well as
a limited form of text-to-speech synchronization.
A particularly nice example of the application of STEP
is a student-project featuring a learning domestic servant,
that listens to natural language input in a more or less intelligent
fashion.
Very complex gestural patterns, however, such as for example
conducting music, pushed our technology to its limits,
as we will discuss more extensively later on.


@+ Agents in multi-user virtual environments

%%The various aspects of our multi-user soccer game are reported
%%in more detail in [_Community].
We chose the soccer game as a demonstrator 
for multi-user virtual environments because it provided us with a number
of challenges, as indicated below  [_Community].

<slide id=pl-mu-socc>
<c>
/// <em>multi-user soccer game</em>
</c><p>
<small>
<ul bullet=red>
<li><em><blue>multiple (human) users</font></em> -- may join during the game </li>
<li><em><blue>multiple agents</font></em> -- to participate in the game (e.g. goalkeeper)</li>
<li><em><blue>reactivity</font></em> -- players (users and agents) have to react quickly</li>
<li><em><blue>cooperation/competition</font></em> -- requires intelligent communication</li>
<li><em><blue>dynamic behavior</font></em> -- sufficiently complex (dynamic) 3D scenes</li>
</ul>
</small>
<navigate/>
</slide>
\noindent
The soccer player agents each have a simple cognitive loop
based on the extended BDI model described in [_Avatars], which may be summarized
as <em>sense</em>, <em>think</em>, <em>act</em>. <footnote>
The users' avatars do not have any cognitive
model, but act directly on the users' keyboard and mouse input.</footnote>
<lp>
%%<so fig-1-a>
<lp>
Furthermore, to allow multiple users to join the
game, taking the place of autonomous agent players if necessary,
we designed a special purpose <em>Agent Communication Language</em>
(ACL) to deal with the communication necessary to keep
the world updated.
%%as previously outlined in the discussion on multi-user virtual environments.
The message format is, schematically: <em>Action, Type, Parameters</em>.
It allows for a wide range of (distributed)
actions, such as the notification of the positions of the player,
the movement of the ball, and the arrival and departure of players.
It is interesting to note that we may significantly optimize
on the communication load if we introduce additional
compound messages such as <em>run &amp; trace ball</em>,
to replace a sequence of primitive messages.

<vrml>
%%\vspace{-3cm}
<slide id=pl-soccer-img>
<image color=white name=@archive/wasp/wasp-soccer1>
</slide>
%%\vspace{-3cm}
%%\noindent          
</vrml>

%%<scene id=pl-soccer-x>
%%<c>
%%<slide id=pl-soccer-protocol>
%%<p><p>
%%<center>
%%<text text=blue x=5 size=1.5> [ Act, Type, Parameters ] </text>
%%</center>
%%<navigate>
%%</slide>
%%</c>
%%<slide id=pl-proto-messages>
%%<c>
%%/// <em>distributed game protocol</em>
%%<p>
%%<small>
%%<ul bullet=red size=0.8>
%%<li><em>register game</em>: [ register, game_name, from(Host) ]</li>
%%<li><em>tell new player</em>: [ tell, new_player, user(Host,Name) ]</li>
%%<li><em>tell kick ball</em>: [ tell, kick_ball, [ user(Host,Name), force(X,Y,Z) ] ]</li>
%%<li><em>ask game score</em>: [ ask, game_score, user(Host,Name) ]</li>
%%</ul>
%%</small>
%%<navigate/>
%%</c>
%%</slide>
%%\noindent
%%%%Other message types include:
%%<c>
%%<slide id=pl-proto-x> <p><blue><set size=0.7>
%%<quote><small>
%%<em>register accept, register wait, tell position, tell rotation, tell game score, reply game score, unregister game, reply unregister game, player gone ...
%%</em>
%%</small></quote>
%%</font><set size=1.0>
%%<navigate/>
%%</slide>
%%</scene>
%%\noindent
%%</c>
%%<so fig-1-b>
%%<so eca-soccer>
<lp>
Although both the graphical quality and the efficiency
(that is reactive speed)
of the soccer game left to be desired,
this application demonstrated the viability of our approach
in terms of resources need for its development.
Despite the complexity of the soccer game, it took only
about two months developers time, whereas our previous experience
with applications using the <url href=http://www.blaxxun.com>blaxxun Community Server</url>
would indicate a far more demanding development path using 'low-level' technology.


@+ Mixed-media presentations with commentators

Desktop VR is an excellent medium for presenting information,
for example in class, in particular when rich media
or 3D content is involved. 
As reported in [_TIDSE],
at VU, we have been using <em>presentational VR</em>
for quite some time, and recently we included dialogs
using balloons (and possibly avatars) to display the text
commenting on a particular presentation, [_Slides].
%%See figure (b) for an example displaying a virtual
%%environment of the VU, a propaganda movie for attracting
%%students, and two avatars commenting on the scene.
%%The avatars and their text are programmed as 
%%annotations to a particular scene as described below.
<lp>
Each presentation is organized as a sequence of slides,
and dependent on the slides (or level within the slide)
a dialog may be selected and displayed.
The dialog is encoded in an XML syntax,
as an alternation between phrases uttered by the agents.
A dialog is activated automatically dependent on
the content of a particular slide.
%%See the <em>observer</em> fragment in section 3.
<lp>
%%As an example, uur annotation for dialog text in slides looks as follows:

<slide color=yellow a=0 id=pl-dialog-phr>
<effect type=style l_persona=-1 r_persona=-1 sky="1 1 1" drop=-1 logo=""/>
<c>
/// <em>dialog</em>
<p>
<small>
<display font=tt>
&lt;phrase right="how~are~you"&gt;
&lt;phrase left="fine~thank~you"/&gt;
%%&lt;phrase right="tell~nme~n..."/&gt;
&lt;phrase right="what do~you think~of studying ..."/&gt;
...
%%&lt;phrase left="yes~neh~n..."/&gt;
%%&lt;phrase right="what do~nyou think~nof studying ..."/&gt;
%%&lt;phrase left="what?~n..."/&gt;
%%&lt;phrase right="the opportunities~n~n!"/&gt;
%%&lt;phrase left="what do~nyou mean?"/&gt;
%%&lt;phrase right="of studying~n..."/&gt;
%%&lt;phrase left="studying what~n...?"/&gt;
%%&lt;phrase right="please~nlet me know~n..."/&gt;
%%&lt;phrase left="yes eh,~nI think ..."/&gt;
%%&lt;phrase right="now,~nwhat do you~nthink?"/&gt;
%%&lt;phrase left="I think~nthat~nstudying~n..."/&gt;
%%&lt;phrase right="what~nabout~nstudying?"/&gt;
%%&lt;phrase left="studying~ninvolves~ndiscipline"/&gt;  
%%&lt;phrase right="yes eh~n?"/&gt;
%%&lt;phrase left="and~nmotivation~n..."/&gt;
%%&lt;phrase right="It is like~nliving!"/&gt;
%%&lt;phrase left="indeed~n!"/&gt;
%%&lt;phrase right="But ~nI am~nnot alive"/&gt;
&lt;phrase left="So,~what~are you?"/&gt;
&lt;phrase right="an ~agent" style="[a(e)=1]"/&gt;
&lt;phrase left="I always~wanted to be~an agent" style="[a(e)=1]"/&gt;
</display>
</small>
</c>
<navigate/>
</slide>
\vspace{-0.5cm}
<v>
<slide id=pl-dial-img>
<image src=local/screens/vu-6.jpg>
</slide>
</v>
\noindent
%%\vspace{-0.5cm}
%%In figure (b), you see the left avatar (named <em>cutie</em>) step forward
%%and deliver her phrase. This dialog continues until <em>cutie</em> remarks that she <em>always wanted to be an agent</em>.
%%The dialog is a somewhat ironic comment on the contents of
%%the movie displayed, which is meant to introduce the VU to 
%%potential students.<footnote> Clearly, our approach is reminiscent
%%to the notorious <em>Agneta &amp; Frida</em> characters
%%developed in the Persona project. See http://www.sics.se/humle/projects/persona/web</footnote>
<lp>
%%Furthermore, 
Our presentational VR system supports a number
of style parameters
to decide for example
whether the avatars or persona are visible, where to place
the dialogs balloons on the display, as well as the color
and transparancy of the balloons.
%%To this end, we have included a <em>style</em> attribute
%%in the <em>phrase</em> tag, to allow for setting
%%any of the style parameters.
%%<c>
%%<slide color=yellow a=0 id=pl-dialog-style>
%%%%<c>
%%/// <em>style parameters</em>
%%%%</c>
%%<p>
%%<small>
%%<display font=tt>
%%&lt;phrase right="red" style="[p=(0.5,0,0),persona=0,balloon=0]"/&gt;
%%&lt;phrase left="cutie" style="[p=(-0.5,0,0),persona=0,balloon=0]"/&gt;
%%&lt;gesture right=1 style=default/&gt;
%%&lt;gesture left=1 style=default/&gt;
%%</display>
%%</small>
%%<navigate/>
%%</slide>
%%\noindent
%%</c><lp>
Apart from phrases, we also allow for gestures, taken from
the built-in repertoire of the avatars as well
as gestures defined using the STEP scripting language.
%%In section 4.3 we discuss how to extend the repertoire
%%of gestures, using a gesture specification language.
Both phrases and gestures are compiled into DLP code
and loaded when the annotated version of the presentation VR
is started.
<lp>
We should note, as we will discuss in section 5.1,
that our approach supports a unified presentation of both
the material and the agents commenting on the material,
unlike the
<em>Agneta &amp; Frida</em> characters
developed in the <url href=http://www.sics.se/humle/projects/persona/web>Persona project</url>.
%%See http://www.sics.se/humle/projects/persona/web</footnote>


@+ Grasping the essence of Tai-Chi, domestic servants and conducting music

The limited repertoire of gestures of standard VRML avatars,
as deployed for example in VRML-based blaxxun Community Server worlds,
quite soon became annoying.
Apart from suitable cognitive rules,
a Web agent should have a convincing repertoire of gestures,
and be able to manipulate objects in its environment.
So, in consonance with the logic programming environment
from which we controlled the cognitive processes
governing our agents, we developed the scripting language STEP
as a dynamic logic for defining actions and gestures on top
of the DLP platform [_STEP].
<lp>
The first demonstrator developed with STEP technology
was a humanoid performing Tai-Chi movements.
Tai-Chi exercises are sufficiently complex, requiring 
parallel motion of the limbs and subtle positioning of the body.
In particular, the possibility to define parallel motions
independently proved to be effective for
concisely modeling the Tai-Chi movements.
A subject subsequently addressed was the use of inverse kinematics
to allow for pointing to body parts and grapsing objects in the world
[_STEP-book].
Since objects may not always be within reach of an agent,
a system of rules was developed to
determine whether the agent should move to the object,
bow towards the object, or simply grasp it [_Reach].
In some cases, a combination of these alternatives
is required to grasp an object from the optimal stance,
taking into account the possible presence of obstructing objects.
<lp>
Later on STEP was extended to support facial animation which,
in combination with text-to-speech,
culminated in a <url href=http://step.intelligent-multimedia.net>virtual presenter</url>
reading out the text of a powerpoint presentation.
Facial animation for speech is triggered by events
generated by the <url href="Microsoft Speech SDK 5.1">text-to-speech engine</url>,
indicating the beginning and end of phonemes.

<c>
<slide id=eca-app-tai>
/// STEP applications
<ul>
<li> tai-chi demonstrator</li>
<li> grasping and reaching, using inverse kinematics and reasoning</li>
<li> facial animation (with  text-to-speech)</li>
<li> virtual presenter -- presenting powerpoint presentation</li>
</ul>
<navigate>
</slide>
</c>

%%<so eca-taichi>

:@ an interactive learning agent for domestic services



<c>
<slide color=white a=0 id=eca-app-servant>
/// domestic servant
<ul>
<li> natural language input</li>
<li> learning and adapting to environment</li>
<li> response: gestures, operations and text</li>
<li> self-explanation</li>
</ul>
%%<display>
%%Conditions, Actions, Effects
%%</display>
</slide>
</c>


STEP has been used, in a student project, for
creating an adaptive learning agent,
that acts as a servant in a domestic environment
[_Interactive].
The agent reacts to natural language input,
which can take the form of requests for information or
commands,
such as "<em>where is the book</em>", "<em>get me the book</em>",
"<em>turn on the television</em>".
After processing the natural language input, the agent 
checks its capabilities to see whether the request
can be answered in an appropriate way.
Capabilities, in this context, may
be regarded as rules relating
<em>Conditions</em>, <em>Actions</em>, and <em>Effects</em>.
A response can be either an answer in text,
a gesture or a sequence of gestures,
or an action involving a modification of the actual world
in which the agent lives,
for example when the television is switched on.
Capabilities, which contain in a sense the agents knowledge
about the world and the recipes or scripts to perform
particular actions, can be extended
by providing the agent with information about the
world or by explicitly instructing the agent
how to perform a particular action.
<lp>
The domestic servant application, apart from being
a non-trivial application of DLP and STEP
involving path-following, complex motions
and inverse kinematics to grasp objects,
has triggered some interesting research issues by itself,
in particular natural language processing and learning actions as
parametrized STEP code fragments.



:@ reusable gestures for musical conducting

<c>
<slide a=0 id=eca-app-conduct>
<include file=plain>
/// musical conductor
<ul>
<li> complex arm and hand movements</li>
<li> gestural primitives (reusable gestures)</li>
</ul>
<p>
:@ issues:
<ul>
<li> amount of parallelism</li>
<li> synchronization -- of intra-gestural and wrt external (musical) source</li>
<li> modulation by mood and style</li>
</ul>
</slide>
</c>

Giving technology out of hands is always an interesting process.
Suddenly one is confronted with completely different
perspectives.
What seems evident may become questionable.
And an approach that always worked may suddenly reach its limit and fail.
In our cooperation with the (former) <url href=http://www.cwi.nl/projects/FASE/>Facial Animation Group</url>
of CWI we experienced such differences in perspective
and encountered limitations of our technology.
<lp>
In [_Conductor], the application of STEP to define gestures
for musical conducting is described.
Conducting music involves the (timed) motion of both arms
and hands, including the fingers.
Whereas we conveniently ignored finger movements in our
Tai-Chi demo, the conductor demo did not allow for such crudeness.
As a result, the number of parallel threads needed
to model the quasi-independent motion of all fingers
presented a serious stumble-block.
Fortunately, we succeeded in significantly reducing the
number of independent threads needed, by introducing
a new primitive that allows for the parallel motion
of body elements (limbs and fingers) using iterated
(quaternion-based) interpolation, which can be done
using only a single thread.
We must note nevertheless that, although an effective solution
for this case, in general the combined motion of all
joints jeopardizes the high level modeling approach
advocated by STEP, which allows for the independent
specification of the motion of body parts.
<lp>
Another issue came up, however,
having to do with the synchronization of gestures
and sound.
On the one hand, there is the problem of precisely synchronizing
the gestures among themselves
(as when conductiong with two independently moving arms),
on the other hand, though,
gestures must be synchronized with musical fragments in
a very precise manner, on the beat so to say.
This becomes even more important when facial animations must be lip-sync
with spoken text.
As discussed in section 4.3, this is where our technology
shows some serious limitations
which require significant redesign and the possible adoption of more
powerful multimedia technology.
%%such as <url href=MSX>DirectX</url>. 
<lp>
On the positive side, 
our cooperation with the CWI group demonstrates that
STEP allows for the development of libraries
of reusable gestures for fairly complex gestural tasks,
as conducting music definitely is  [_Reusable].
In all respects, the work done by the CWI people
provides great impetus for the future development
of our platform.






@* Technology -- declarative programming

In section 2 we have hinted at a preference for a programmatic
approach to control the functionality of embodied agents.
However, this may easily be misunderstood, and must certainly
not be taken as to advocate a hackers approach to develop
agent-based systems.
To the contrary, in line with proposition 5, we adopted
a fully declarative approach.
Declarative, in this context, means that the code should be
understood as a specification of the desired properties of
the system, and not (only) by means of an operational
interpretation based on some complex execution model.
In fact, our platform is unique in that it is uniformly logic-based,
both on the level of specifying the cognitive processes
of the agents as in the specification of gestures and actions.
And to the extent possible, even events within the 3D environment
are controlled by a logical specification of sorts.
<lp>
In this section we will describe the technological basis of our 
platform, 
as originally described in [_Platform].
More extensive descriptions can be found in [_STEP-imp]. 
In section 4.3, however, we will discuss the issues concerning
the technological limitations of our platform, as hinted at
in [_Conductor].

@+ The DLP+X3D platform


%%... distributed web computing [_WebComputing],
%%[_Platform].


In [_Community], we have described a platform for virtual
environments based on agent technology.
In effect, our platform is the result of merging VRML
with the distributed logic programming language DLP,
using the VRML External Authoring Interface.
This approach allows for a clear separation of concerns,
modeling 3D content on the one hand and determining the
dynamic behavior on the other hand.
More recently we have adopted X3D as our 3D format.
The VRML profile of <url href=http://www.web3d.org/fs_x3d.htm>X3D</url> is an XML encoding of VRML97.
%%<footnote>http://ww.web3d.org/fs_x3d.htm</footnote>
<lp>
The language DLP is a distributed object-oriented extension
of Prolog [_DLP].
It supports multiple inheritance, non-logical instance
variables and multi-threaded objects (to allow for distributed
backtracking).
Object methods are collections of clauses.
Method invocation is dealt with as communication by rendez-vous,
for which synchronization conditions may be specified in
so-called <em>accept</em> statements.
The current implementation of DLP is built on top of Java.
<lp>
To effect an interaction between the 3D content
and the behavioral component written in DLP,
we need to deal with two issues:

<slide id=pl-control>
<c>
/// DLP+X3D   
</c><p>
<small>
<ul size=1.5 bullet=red>
<li> control points: <em>get/set</em> -- position, rotation, viewpoint </li>
<li> <em>event-handling</em> -- asynchronous accept</li>
</ul>
</small>
<navigate/>
</slide>
\noindent
We will explain each of these issues separately below.
In addition, we will indicate how multi-user environments
may be realized with our technology.

:@ control points 
The control points are actually nodes in the VRML scenegraph
that act as handles which may be used to manipulate the scenegraph.
In effect, these handles are exactly the nodes that may act as the
source or target of event-routing in the 3D scene.
As an example, look at the code fragment below,
which gives a DLP rule to determine whether a soccer player
must shoot:

<slide color=blue a=0 id=pl-dlp-attr>
<c> 
/// soccer rule
</c>
<p>
<small>
<display text=white font=tt>
findHowToReact(Agent,Ball,Goal,shooting) :-
   get(Agent,position,sfvec3f(X,Y,Z)),
   get(Ball,position,sfvec3f(Xb,Yb,Zb)),
   get(Goal,position,sfvec3f(Xg,Yg,Zg)),
   distance(sfvec3f(X,Y,Z),sfvec3f(Xb,Yb,Zb),DistB),
   distance(sfvec3f(X,Y,Z),sfvec3f(Xg,Yg,Zg),DistG),
   DistB =< kickableDistance,
   DistG =< kickableGoalDistance.
</display>
</small>
<navigate/>
</slide>
\vspace{-0.5cm}
\noindent
This rule will only succeed when the actual distance
of the player to the goal and to the ball
satisfies particular conditions.
%%<lp>
In addition to observing the state of the 3D scene
using the <em>get</em> predicate,
changes to the scene may be effected using the <em>set</em>
predicate.

:@ event handling 
Our approach also allows for changes in the scene that
are not a  direct result of setting attributes
from the logic component.
Therefore we need some way to intercept events.
%%<lp>
In the example below, we have specified an observer object
that has knowledge of, that is inherits from, an object
that contains particular actions.
<lp>
<slide color=blue a=0 id=pl-dlp-observer>
<c>
/// <em>observer</em>
</c>
<small>
<display text=white font=tt>
:- object observer : [actions].
var slide = anonymous, level = 0, projector = nil.

observer(X) :- 
   projector := X,
   repeat,
     accept( id, level, update, touched),
   fail.

id(V) :-  slide := V.
level(V) :- level := V.
touched(V) :- projector$<-$touched(V).
update(V) :- act(V,slide,level).
:- end_object observer.
</display>
</small>
</slide>
\noindent
The constructor sets the non-logical variable <em>projector</em>
and enters a repeat loop to accept
any of the incoming events for respectively <em>id</em>,
<em>level</em>, <em>update</em> and <em>touched</em>.
Each event has a value, that is available as a parameter
when the corresponding method is called on the acceptance
of the event.
To receive events, the <em>observer</em> object
must be installed as the listener for these particular events.
<lp>
The events come from the 3D scene.
For example, the <em>touched</em> event results from mouse clicks
on a particular object in the scene.
On accepting an event, the corresponding method or clause
is activated, resulting in either changing the value
of a non-logical instance variable,
invoking a method,
or delegating the call to another object.
<lp>
An observer of this kind is used in the system described in section 3.2,
to start a comment (dialog) on the occurrence of a particular slide.

@+ STEP -- a scripting language for embodied agents

%%Given the use of humanoid avatars to comment on the
%%contents of a presentation, we may wish to enrich
%%the repertoire of gestures and movements to be able,
%%for example, to include gestural comments or even
%%instructions by gestures.
%%<lp>
STEP is a scripting language for
humanoids based on dynamic logic.
The STEP scripting language consists of basic actions,
composite operators and interaction operators (to deal
with the environment in which the movements and actions take place).
%%See [_STEPIMP] and [_STEPX].
See [_STEP-imp]
<lp>
The basic actions of STEP consist of:

<slide id=pl-step-actions>
<c>
/// <em>basic actions</em>
</c><p>
<small>
<ul>
<li> <em>move</em>  -- <tt>move(Agent,BodyPart,Direction,Duration)</tt> </li>
<li> <em>turn</em> -- <tt>turn(Agent,BodyPart,Direction,Duration)</tt> </li>
</ul>
</small>
<navigate/>
</slide>
\noindent
These basic actions are translated into operations
on the control points as specified by the H-Anim 1.1 standard.
<lp>
As composite operators we provide sequential and parallel
composition, as well as <em>choice</em> and <em>repeat</em>.
These composite operators take both basic actions and user-defined 
actions as parameters.
<c>
<slide id=pl-step-composite>
/// <em>composite operators</em>
<p>
<small>
<ul>
<li> <em>sequence</em> -- <tt>[Action_1,...,Action_{n}]</tt> </li>
<li> <em>parallel</em> -- <tt>parallel([Action_1,...,Action_{n}])</tt></li>
<li> <em>choice</em> -- <tt>disjunct([Action_1,...,Action_{n}])</tt></li>
<li> <em>repeat</em> -- <tt>repeat(Action,k)</tt></li>
</ul>
</small>
<navigate/>
</slide>
\noindent
</c>
<lp>
Each action is defined using the <em>script</em>,
by specifying an action list containing
the (possibly compound) actions of which that particular
action consists.
As an example, look at the definition of <em>walking</em> below.


<slide color=blue a=0 id=pl-step-example>
<c>
/// <em>example</em>
</c><p>
<small>
<display text=white font=tt>
script(walk(Agent), ActionList) :-
ActionList = [
  parallel([turn(Agent,r_shoulder,back_down2,fast),
 	turn(Agent,r_hip,front_down2,fast),
 	turn(Agent,l_shoulder,front_down2,fast),
 	turn(Agent,l_hip,back_down2,fast)]),
  parallel([turn(Agent,l_shoulder,back_down2,fast),
 	turn(Agent,l_hip,front_down2,fast),
 	turn(Agent,r_shoulder,front_down2,fast),
 	turn(Agent,r_hip,back_down2,fast)])
], !.
</display>
</small>
<navigate/>
</slide>
\vspace{-0.5cm}
\noindent
Notice that the <em>Agent</em> that is to perform the
movement is given as a parameter.
(Identifiers starting with a capital act as a logical parameter
or variable in Prolog and DLP.)
%%<so fig-1-c>
<c><vrml>
<slide id=pl-step-img>
<image src=@archive/wasp/walk.jpg>
</slide>
</vrml></c>
<lp>
Interaction operators are needed to conditionally
perform actions or to effect changes within the environment
by executing some command.
Our interaction operators include: <latex>
<em>test</em>, <em>execution</em>, <em>conditional</em>
and <em>until</em>.
</latex>
<c>
<slide id=pl-step-interacton>
/// <em>interaction</em>
<p>
<small>
<ul>
<li> <em>test</em> -- <tt>test(State)</tt> </li>
<li> <em>execution</em> -- <tt>do(State)</tt> </li>
<li> <em>conditional</em> -- <tt>if_then_else(State,Action1,Action2)</tt>  </li>
<li> <em>until</em> -- <tt>until(Action,State)</tt></li>
</ul>
</small>
<navigate/>
</slide>
\noindent
</c>
<lp>
Potentially, an action may result in many parallel
activities.
To control the number of threads used for an action,
we have created a scheduler that assigns
activities to a thread from a thread pool consisting
of a fixed number of threads.
%%<lp>
%%As a demonstrator for STEP, we envisage to create
%%an instructional VR for <em>Tai Chi</em>,
%%the Chinese art of movement.

:@ XML encoding 
Since we do not wish to force the average user
to learn DLP to be able to define scripts in STEP,
we are also developing XSTEP, an XML encoding for STEP.
We use <em>seq</em> and <em>par</em> tags as found in
<url href=http://www.w3.org/AudioVideo>SMIL</url>,
as well as <em>gesture</em> tags with appropriate attributes
for speed, direction and body parts involved.
See [_XSTEP].
%%<c>
As an example, look at the XSTEP specification
of the <em>walk</em> action.
<slide color=yellow a=0 id=pl-step-ex-xml>
<c>
/// XSTEP 
</c>
<small>
<display>
&lt;action type="walk(Agent)"&gt;
&lt;seq&gt;
 &lt;par speed="fast"&gt;
  &lt;gesture type="turn" actor="Agent" part="r_shoulder" dir="back_down2"/&gt;
  ...
%%&lt;gesture type=turn actor=Agent part=r_hip dir=front_down2/&gt;
%%&lt;gesture type=turn actor=Agent part=l_shoulder dir=front_down2/&gt;
%%&lt;gesture type=turn actor=Agent part=l_hip dir=back_down2/&gt;
 &lt;/par&gt;
 &lt;par speed="fast"&gt;
%%&lt;gesture type=turn actor=Agent part=l_shoulder dir=back_down2/&gt;
%%&lt;gesture type=turn actor=Agent part=l_hip dir=front_down2/&gt;
%%&lt;gesture type=turn actor=Agent part=r_shoulder dir=front_down2/&gt;
  ...
  &lt;gesture type="turn" actor="Agent" part="r_hip" dir="back_down2"/&gt;
 &lt;/par&gt;
&lt;/seq&gt;
&lt;/action&gt;
</display>
</small>
<navigate/>
</slide>
\vspace{-0.5cm}
\noindent
%%</c>
Similar as with the specification of dialog phrases,
such a specification is translated into the corresponding
DLP code, which is loaded with the scene it belongs to.
For XSTEP we have developed an XSLT stylesheet, using
the <url href=http://saxon.sourceforge.com>Saxon</url> package, that transforms an XSTEP specification into DLP.
%%We plan to incorporate XML-processing capabilities in DLP,
%%so that such specifications can be loaded dynamically.

:@ Ontologies
One particular feature of STEP that should be mentioned
is the use of ontologies, to shield the programmer/developer
from the low-level numerical specification of actual
values for timing and motions in 3D space.
Ontologies form an intermediate interpretative layer that
assigns actual values to natural language-like 
temporal specifications
such as <em>fast</em> and <em>slow</em>,
and body movement specifications such as <em>down</em> and <em>up</em>.
This intermediate layer is appropriately called an ontology
since it characterizes the properties of the world
in which the agent lives,
taking into account the agents frame of reference.


@+ On parallelism, synchronization and runtime performance

Complex humanoid gestures are of a highly parallel nature.
The STEP scripting language
supports a direct way of modelling parallel gestures
by offering a parallel construct
(<em>par</em>), which results in the simultaneous
execution of (possibly compound) actions.
<lp>
To avoid unconstrained thread creation, 
the STEP engine makes use of a thread pool,
containing a fixed number of threads,
from which threads are allocated to actions.
Once the action is finished, the thread is put back in
the pool.
<lp>
This approach works well for most examples.
However when many threads are needed,
as in the conductor example
(which requires approximately 60 threads),
problems may occur, in particular when there are may background jobs.
<lp>
When using parallelism three types of potential
problems may be distingushed:
<slide a=0 id=eca-parallel>
<c>
/// parallelism>
</c>
<small>
<ul>
<li> synchronisation among gestures,</li>
<li> (reliable) timing of gestures, and</li>
<li> synchronisation of gestures with external events, e;g.audio.</li>
</ul>
</small>
<navigate>
</slide>
\noindent
Synchronisation among gestures requires that gestures
that are meant to be executed simultaneously
do indeed start and end at the same time.
Unwanted delays however may occur, for example,
when there are nested parallel constructs, due to
the processing needed to unravel compound gestures.
One remedy here is to optimize the Prolog engine,
which is an ongoing effort.
Another, equally obvious, remedy is to eliminate
nested parallel constructs by some sort of flattening.
These  solutions require no or only a minor change to the STEP engine
implementation.
In effect, we have introduced a <em>par_turn</em> construct
that allows to declare the parallel rotation of an arbitrary
number of joints.
However, such a construct, when applied exclusively,
limits modelling to defining what can best be called successive
'frames' of a motion, which runs counter the approach advocated
by STEP, namely defining gestures in a natural way,
as concurrent motions of the human body.
<lp>
To solve the problem of reliable timing in a more fundamental
way would require not
only a modification of the STEP engine,
but also a rather different implementation
of the DLP threads supporting the parallelism in STEP.
Currently, the implementation only allows for
<em>best effort</em> parallelism and does not provide
the means for <em>deadline scheduling</em>.
<lp>
Synchronisation with external events is possible,
to the extent that such external events are supported
by the VRML/X3D environment.
That does at this stage, unfortunately, not include
the synchronisation with audio events,
unless an audio track is broken up in separate pieces.
%%One issue to work on, in the future,
%%is the synchronisation with voice,
%%using the events generated by a <em>text-to-speech</em> engine.
<lp>
Summarizing, as concerns the use of parallelism in modeling
gestures we run into a number of problems which are either
caused by exhausting the resources of the machine,
inefficiencies in the execution of Prolog code,
or limitations of the thread model supported by DLP.
Partial remedies include, respectively,
reducing the number of threads needed,
eliminating nested parallel constructs,
optimizing the Prolog execution engine, and a push-down
of critical code of the STEP engine to the Java level.
These measures can be taken without affecting the 
STEP engine or the underlying DLP thread model.
<lp>
Nevertheless, there remains still some concern whether 
the inherent inefficiencies of the Java platform and the VRML
Java External Authoring Interface can be overcome in a satisfying degree.
Therefore, we have recently started to develop a version of DLP
and STEP for the Microsoft .NET platform, which we believe
that in combination with Direct3D based implementations of
3D graphic models allow for better control of the issues
that we identified as problematic, in particular
thread control, synchronization and interaction with a dynamic environment.
As a preliminary result, we can mention that our Prolog implementation
in the .NET C\# language already runs ten times faster than
our Java implementation on a standard set of Prolog programs.

@* Evaluation -- validating agent-based applications

Propositions 1 and 2 in the introductory section emphasize
the need for meaningful content.
In particular, as indicated in propositions 3 and 4,
agent behavior must be meaningful and, in the perception of the user,
be naturally embedded in its environment.
In this section we comment briefly on our use of agents
in presentational VR, as described in section 3.2.
More importantly, however, we will outline how to approach
the validation of agent-based systems from a user perspective,
building on a theory of agents as fictitious characters.
Finally, we will indicate some future research issues,
including scenario(s) for the experimental evaluation
of (the added value provided by) embodied conversational agents.

@+ Narrative structure and presentations

Dialogs, as introduced in section 3.2, have a well-defined
temporal structure,
with alternating turns for the two (virtual) speakers.
Mixed media, that is the combination of dialogs
with rich media and virtual environments,
may endanger the narrative structure of a presentation,
due to conflicts between the narrative structures of the
distinct media items.
%%Each of these media entities may have a distinct narrative structure.
Slides are sequentially organized, and each slide may have levels
that are displayed in a sequential fashion.
The narrative structure of digital video may be
arbitrarily complex, and may make full use
of cinematographic rethorics.
Navigation and interaction in virtual environments
may be seen as a weak narrative structure, which may however 
be strengthened by guided tours or viewpoint transformations,
taking the user to a variety of viewpoints
in a controlled manner.
<lp>
%%In the following we will compare our approach to
%%Related research and investigate what possible advantages
%%we may obtain from <em>mixed media</em> presentations.

%%<slide id=dia-condis-title color=red a=0>
<c>
:@+ consonant or dissonant comments
</c>
%%</slide>
<scene show=on color=yellow text=white a=0 id=dia-scene-perspectives>
<phrase id=dia-scene-perspectives level=0 turn=0 right="remember those?"/>
<phrase id=dia-scene-perspectives level=0 turn=0 left="yes~nI do!"/>
<slide level=0 color=blue a=0 text=white id=dia-con-dis>
<p>
%%<slice text=white><p>
<text trans="11 -5.5 5" a=0.1 annot=@archive/annot/agneta.gif>Our approach is clearly reminiscent to the notorious</text>
<em>Agneta &amp; Frida </em>
characters developed in the <url href=http://www.sics.se/humle/projects/persona/web>Persona</url> project.  </slide>
The Persona project aims at:
investigating a new approach to navigation through information spaces,
based on a personalised and social navigational paradigm [_Social].
The novel idea pursued in this project is to have agents (Agneta and
Frieda) that are not helpful, but instead just give comments, sometimes
with humor, but sometimes ironic or even sarcastic comments on the
user's activities, in particular navigating an information space or
(plain) web browsing.  <slide id=dia-xx-2> <p level=1> 
%%<lp>
In contrast with the Personas project, our (dialog) comments are part of a presentation which of itself has a definite narrative structure, in opposition to the 'random' navigation that occurs by browsing 'information spaces'.  </p></slide> </scene>
As a consequence, our comments may be designed
taking the expected reaction of the audience
into consideration.
An interesting question is whether comments should be <em>consonant</em>
with the information presented (drawing attention to particular aspects)
or <em>dissonant</em> (as with ironic or sarcastic comments).

%%<slide id=dia-t-p-2 color=red a=0>
<c>
:@+ engagement versus immersion 
</c>
%%</slide>
<slide show=on color=red a=0 text=white id=dia-con-enga>
<phrase level=0 turn=0 right="Is that so?"/>
<phrase level=0 turn=0 left="I am~nnot a student!"/>
<phrase level=1 turn=0 right="..."/>
<phrase level=1 turn=0 left="You can say~nthat again!"/>
<slice><p>
The characters and dialog text may be used to enliven the material.<p>
In this way, the students' engagement with the material may be increased [_Engagement].<slice><p>  Clearly, there is a tension between engagement and immersion.</slide>
Immersion, understood as the absorption within a familiar
narrative scheme (in our case the lecturer's presentation),
may be disrupted by the presence of (possibly annoying)
comments, whereas the same comments may lead the attention
back to the material, or
provide a foothold for affective reactions to the material [_Reactions].
Also, the audience might start to anticipate the occurrence
of a dialog and possibly identify themselves with one
of the characters.


%%<slide id=dia-t-p-3 color=red a=0>
<c>
:@+ emotional enhancement
</c>
%%</slide>
<slide show=on color=yellow a=0 text=white id=dia-con-enha>
<phrase level=1 turn=0 right="That seems~n a fair question."/>
<phrase level=1 turn=0 left="Yes,~nit is"/>
<phrase level=2 turn=0 right="virtual?"/>
<phrase level=2 turn=0 left="no, stupid~nnatural!"/>
<slice>
<p>
In one of her talks, Kristina H&ouml;&ouml;k observed that some users get really fed up with the comments delivered by Agneta and Frieda. Nevertheless, it also appeared that annoyance and irritation increased the emotional involvement with the task.<slice><p>
For our presentations, we may ask how <em>embodied agents</em>   may help in increasing the emotional involvement of the audience or, phrased differently, how dialogs may lead to emotional enhancement of the material [_Enhancement].<slice>
<p> An important difference with the Personas project is that our platform supports the actual merge of dialogs and the humanoid characters that deliver them in a unified presentation format, that is a rich media 3D graphics format based on X3D/VRML. <p>
As a consequence, the tension between immersion and engagement may be partially resolved, since the characters delivering the dialog may be placed in
their 'natural' context, that is a virtual environment. </slide>
%%as in example (a). 

@+ Embodied agents as fictional characters

<slide id=eca-pefic><p>
In [_PEFIC0] the following observation was made:
<quote>
Observation: VR is fiction and fiction is as old as humanity.
</quote>
\noindent
<p>This observation which is a different theoretical context
(re)affirmed in [_Remediation],
leads to the following, rather obvious, corollary:
<quote>
Corollary: subjective feeling of involvement 
with fictional situation is achieved by intentional suspension of
disbelief.
</quote></slide>
\noindent
The corollary is equally valid for embodied conversational
agents.
In [_PEFIC0] and [_PEFIC], a theory is developed (PEFiC),
concerning <em>Perceiving and Experiencing Fictional Characters</em>,
that may serve as the basis for the experimental evaluation
of user responses to embodied agents.
In summary, PEFiC distinguishes between three phases,
<em>encoding</em>, <em>comparison</em> and <em>response</em>,
in analyzing the user's behaviour towards an agent.
Encoding involves positioning the agent (or fictitious character)
on the dimensions of <em>ethics</em> (good vs bad),
<em>aesthetics</em> (beauty vs ugliness) and
<em>epistemics</em> (realistic vs unrealistic).
Comparison entails establishing personal relevance
and valence towards the agent.
Response, finally, determines the tendency to approach
or avoid the character, in other words involvement versus distance.

<c>
<slide color=white a=0 id=eca-pefic>
<small>
/// PEFiC
<p>
<b>phase 1 -- encoding</b>
<ul>
<li> ethics -- good vs. bad</li>
<li> aesthetics -- beauty vs ugliness</li>
<li> epistemics -- realistic vs. unrealistic</li>
</ul>
<p>
<b>phase 2 -- comparison</b>
<ul>
<li> establishing personal relevance, mutual similarity and valence towards fictional character</li>
</ul>
<p>
<p>
<b> phase 3 -- response</b>
<ul>
<li> involvement vs distance -- tendency to approach or avoid</li>
</ul>
%%See [_PEFIC0] and [_PEFIC].
</small>
</slide>
</c>

Empirical support for the PEFiC-model was found
using structured questionnaires with various character
types and focusing on different aspects of the model.
The characters against which the PEFiC-model was tested ranged
from animated Web agents, such as Bonzi Buddy [_Bonzi],
to Hollywood feature film characters, [_PEFIC],
to pictorial representations of world leaders [_MediatedPeople].
Underlying this range was a continuum of realism in depiction.
Bonzi Buddy was the most unrealistic,
cartoon-like, representation of a living creature,
followed by fantasy figures played by real actors, 
such as Dracula and Superman, 
in the film studies.
The film studies also investigated more realistic characters (e.g., Gandhi),
while the study of world leaders explored the most realistic
representations,
that is, newspaper pictures of, for example,
president Bush and Bin Laden.



@+ Future research directions

Looking back, we succeeded in creating a platform
for embodied agents that may potentially satisfy propositions 1-5,
uniformly based on (some variant of) logic, suitable
for creating web-based 3D agent applications.
Looking to the future, there is still a lot of work to do.
Technical work, to solve the problems we encountered
with respect to synchronization and parallelism,
as well as work to enhance the support for multimedia.
At this stage it is, however, also important to define
proper evaluation scenarios and to set new challenges
against which to validate the future technological
enhancements of our platform.


<c>
<slide a=0 id=eca-issues>
/// issues
<p>
<ul>
<li> synchronization and parallelism</li>
<li> multimedia (technology) support</li>
<li> validation</li>
</ul>
</slide>
</c>

:@ validation scenario(s)
In section 5.1, we already (implicitly) identified
two interaction paradigms, namely <em>pure navigation</em>
and <em>guided tours</em> or presentations that are based
on some narrative structure.
Both paradigms can be augmented using embodied
conversational agents, which in the case of navigation 
might merely give directions and, in the case of guided tours,
may explain what is going on, possibly offering the user
a choice of continuations.
In cooperation with the Faculty of Social Sciences, we have submitted
a research funding proposal to undertake such evaluation studies,
based on the PEFiC theory outlined in section 5.2.
In this proposal [_VUBIS], we focused in particular on the relation between
the type of agent (character)
and the material presented (context),
to determine how this relation affects the valence of the 
user towards the agent, resulting in the degree of distance or involvement
experienced.

<c>
<slide a=0 id=eca-scenarios>
/// validation scenario(s)
<ul>
<li> navigation -- <em>pure</em> interactivity</li>
<li> guided tours -- using some narrative structure</li>
<li> agent-mediated -- navigation and guided tours</li>
</ul>
<p><p><p><p><blue>
             additional variation by agent-characteristics ...
</blue>
<navigate>
</slide>
</c>

:@ case study
Apart from the evaluation studies mentioned above,
we also plan to target a new case study, that brings
many challenges with it.
The project is to be done in cooperation with
the <em>Dutch Cultural Heritage Institute</em>
(<url href=http://www.icn.nl>ICN</url>)
in the context of
the <em>International Network for the Conservation of
Contemporary Art</em>
(<url href=http://www.incca.org>INCCA</url>).
Briefly, the idea is to develop so-called <em>digital dossiers</em>
for individual artworks, allowing professionals
to deal with the information involved in an integrated,
highly interactive fashion.
The following project assignment may serve as a characterization of the
notion of digital dossier:
<slide a=0 color=blue id=eca-dossier>
<c>
/// digital dossier
</c>
<lp><quote><small><em>
Create a VR that realizes a digital dossier for a work of a particular artist. A digital dossier represents the information that is available for a particular work of art, or a collection of works, of a particular artist. The digital dossier should be multimedia-enhanced, that is include photographs, audio and other multimedia material in a compelling manner. 
</em></small></quote>
</slide>
\noindent
Note that <em>dossier</em> is an existing english word,
which according to the
<em>Webster New World Dictionary</em> has the following meaning
<small>
<ul>
<li> dossier (dos-si-er) [Fr < dos (back); so named because labeled on the back] a collection of documents concerning a particular person or matter 
</ul>
</small>
It is closely related to the notion of archive, but there 
is a different focus:
<small>
<ul>
<li> archive [...] 1) a place where public records are kept ... 2) the records, material itself ... 
</ul>
</small>
\noindent
In relation to the evaluation studies mentioned before,
we must investigate what role embodied agents may play
in presenting such digital dossiers to the user,
and how the agents should appear, that is what services
are offered and what the actual presence of the character
must be.


@* Conclusions

<slide id=eca-concl>
<p>
In this paper we presented a platform for embodied conversational
agents, by reflecting on the motivations underlying its
development.
We characterized the functionality of the platform
by discussing a selected number of applications,
illustrating its features, and we included a discussion
of its potential limitations.
A brief description of our uniformly logic-based
technology was given and we concluded by
sketching how to validate the platform against
actual user experience.
Nevertheless, despite the relative maturity of the platform,
we see many challenges for its future enhancement
needed for the realization of new target demonstrators.
</p>
</slide>

%%\small
<include file=@biblio/refs>
</document>
