<document>
%%:Try out
%%A
%%<+0.7><line bgcolor="1 0 0" bgtrans=0.7>colored
%%<line>line
%% Note: %% starts a line of comment
<slide id=sl-rif>
:@ the RIF slides Format
%%/// <a href=slides.t><gold>(source)</gold></a>
/// <a href=title-slides.html><red><em>What is the secret of the slides?</em></gold></a>
<include file=plain>
<p>
It is intended to be a 3D enhanced version
of Microsoft Powerpoint.
We admit however that our socalled .pvl format
lacks many of Powerpoint original features.
But, on the other hand, Powerpoint does not offer
many of the features we provide.
%% In the .tm format :A ... starts a new slide
</slide>

<slide id=sl-pvl>
:@ the pvl format language
<p>
We use a simplified form of <b>HTML</b>, with some additional features.
%% :@ and :@* :@+ :@- is .t legacy,
%% used for chapter, it translates into h4 and h1 h2 h3
%% The text must be on one line!
</slide>
<slide id=sl-example>
:@ example
<display>
 <slide id=x-1 caption="A slide">
 <h4>A header</h4>
 <ul>
 <li> item 1 </li>
 <li> item 2 </li>
 </ul>
 </slide>
</display>
<p>
A description of the origin of this approach can be found at
<display>
 http://www.cs.vu.nl/~eliens/online/hush/manuals/man/man8/ht-ml.html
 http://www.cs.vu.nl/~eliens/online/papers/htf4
</display>
</slide>

<slide id=sl-display>
:@ displaying slides
The slides can be displayed in a number of ways:
<ul>
<li> in latex, text slides </li>
<li> in (dynamic) HTML, for presentation </li>
<li> in VRML, for presentation and the annotation of virtual worlds </li>
</ul>
<p>
To realize presentations a collection filters is needed,
among which the <em>vr-ml.flt</em>
<p>
For how the slides are used see also:
<display>
http://www.cs.vu.nl/~eliens/online/guide.html
</display>
</slide>

<slideid=sl-level>
:@ presentation level
<p>
In VRML display mode, there may be multiple levels in a slide.
Levels are used to allow for incremental presentation of the content
of slide. 
<p>
Each element in a slide, may have an indication of <em>start</em>
and <em>end</em> level.
Some tags allow for a indicating automatic increments
of the <em>start</em> level, which is usually indicated
with <em>level=auto</em>.
</slide>

<slide id=sl-create>
:@ creating slides
<p>
There are a number of contexts, and associated file types,
in which slides may be created:
<ul>
<li> .t -- the ultimately generic format, uses all filters  </li>
<li> .tm -- limited .t format with VRML support, uses ht-ml.flt + vr-ml.flt </li>
<li> .pvl -- VRML slides support, uses vr-ml.flt -pvl </li>
<li> .es  -- for the use of slides in worlds </li>
</ul>
<p>
See example makefiles for actual usage
</slide>

<slide id=sl-vr-ml>
:@ parameters for vr-ml.flt
<p>
<ul>
<li> none -- plain generation of VRML </li>
<li> -pvl -- generates pvl includes </li>
<li> -x -- creates also links for hrefs (UDF) </li>
</ul>
</slide>

<slide id=sl-after>
:@ afterthoughts on formatting
<p>
The VRML protos supporting the slides format must be kept simple
and basic. In some cases extra tags are needed to get the
desired result (or an approximation of that).
</slide>

<slide id=sl-extra>
:@ extra tags
<ul>
<li> &lt;+<em>n</em>&gt; -- create n additional horizontal space (float n) </li>
<li> &lt;-<em>n</em>&gt; -- for negative spacing </li>
</ul>
:@ beware of
<ul>
<li> always use a &lt;p&gt; tag after ending a list or display. </li>
</ul>
<p><p>
Also, the filtering is done on an as best as possible
basis. In some cases it will be very hard to get
what you want.
Actually, since it is a legaccy format, you're not even supposed to use
it. So, why bother.
</slide>

<slide id=sl-design>
:@ on the design of the tag structure
<p>
To accomodate the various modes of formatting and
the various uses that can be made of the slide format,
we make a number of assumptions:
<ul>
<li> processing (in presentation mode) should be fast </li>
<li> the tags must be intuitive, and easy to type (keyboard-wise) </li>
<li> the tags must support a sufficiently rich rethoric repertoire </li>
</ul>
</slide>
<slide id=sl-slidetag>
:@ the slide tag
<ul>
<li> id -- unique name (obligatory) </li>
<li> caption -- slides caption (for use in latex) </li>
<hr>
<li> mode --  UDF (undocumented feature) </li>
<li> style -- generic style attribute (UDF) </li>
<hr>
<li> transform attributes --  trans, scale, rotate </li>
<li> (VRML) style tags -- bgcolor, textcolor   </li>
</ul>
</slide>

<slide id=sl-text>
:@ the text tag (VRML only)
<ul>
<li> transform attributes --  trans, scale, rotate </li>
<li> (VRML) style tags -- bgcolor, textcolor   </li>
</ul>
</slide>

,slideid=sl-uol>
:@ the list tags: ul and ol
<p>
Both unnumbered and numbered list are allowed,
as in HTML
<ul>
<li> level -- with level=auto the bullets will appear in order </li>
<li> additional attributes -- UDFs </li>
</ul>
<p>
To indicate items in a list use the <em>&lt;li&gt;</em> tag.
When additional lines are need, use the <em>line</em> tag.
:@ beware (<red>may/must change (MC)</red>)
<p>The text after a bullet or number must be on one line,
additional lines need to be indicated with a tag.
</slide>

<slide id=sl-dl>
:@ the <em>dl</em> list tag
<p>
Should have
<ul>
<li> level </li>
</ul>
<p>Use the &lt;dt&gt; and &lt;dd&gt; tags to create
the items for the list.
</slide>

<slide id=sl-display>
:@ displays
<p>
To allow for unformatted text, such as program text
the <em>display</em> tag is supported, which is like 
the &lt;pre&gt; tag in HTML.
<ul>
<li> level -- with level=auto lines will appear in order </li>
<li> size  -- to give the size of the text used in the display </li>
</ul>
</slide>
<slide id=sl-font>

:@ the font tag
<ul>
<li> color </li>
<li> size </li>
<li> style </li>
<li> family </li>
</ul>
</slide>

<slide id=sl-f-abr>
:@ font abbreviations
<ul>
<li> &lt;i&gt;...&lt;/i&gt; -- <i>italic</i> </li>
<li> &lt;b&gt;...&lt;/b&gt; -- <b>bold</b> </li>
<li> &lt;em&gt;...&lt;/em&gt; -- <em>emphasize</em> </li>
<li> &lt;tt&gt;...&lt;/tt&gt; -- <tt>typewriter</tt> </li>
<li> &lt;rm&gt;...&lt;/rm&gt; -- <rm>roman</rm> </li>
</ul>
</slide>

<slide id=sl-f-col>
:@ font color abbreviations
<ul>
<li> &lt;red&gt;...&lt;/red&gt; -- <red>red</red> </li>
<li> &lt;blue&gt;...&lt;/blue&gt; -- <blue>blue</blue> </li>
<li> &lt;yellow&gt;...&lt;/yellow&gt; -- <yellow>yellow</yellow> </li>
<li> &lt;green&gt;...&lt;/green&gt; -- <green>green</green> </li>
<li> &lt;white&gt;...&lt;/white&gt; -- <white>white</white> </li>
<li> &lt;black&gt;...&lt;/black&gt; -- <black>black</black> </li>
<li> &lt;gold&gt;...&lt;/gold&gt; -- <gold>gold</gold> </li>
<li> &lt;silver&gt;...&lt;/silver&gt; -- <silver>silver</silver> </li>
</ul>
</slide>
<slide id=sl-object>
:@ the <em>object</em> tag
<object>
Transform { translation 9 0 -4 children [
    <include file=sensor.wrl>
   ] }
</object>
<p>
<break size=1>
It might be worthwhile to incorporate VRML objects
in a slide. These are only visible in VRML, naturally.
<p>
As an example:
<green><display>
&lt;object>
Transform { translation 9 0 -4 children [
&lt;include file=sensor.wrl&gt;
] }
&lt;/object> 
</display></green>
<p>
Note that the VRML text is automatically hidden
when using the object tag.
The <em>include</em> tag is a feature of the .t format.
</slide>
<slideid=sl-hide>
:@ hiding VRML
<p>The <em>&lt;vrml&gt;</em> and
<em>&lt;/vrml&gt;</em> tags are needed if you don't want
your VRML code to be displayed in HTML.
</slide>
</document>
